#!/usr/bin/env python
import sys
import wx
import os
import math
import struct
import string
import numpy as np
from numpy import *
from decimal import *
from StringIO import StringIO

fileout = open("COMPaRS.log", 'w')

btnSave = [" "," "]

qrank = 0.90
ndfun = 20
mhis = 100000
shis = 100
fstat = 0
ftype = 0
iclean = 0
ma = mb = mc = ntot = 0
meps = 1000000
lmem = 500000

fquantr = 0
flagfile1, flagfile2, flagfile3 = 0, 0, 0
ffile1, ffile2, ffile3 = 0, 0, 0
ifile1, ifile2, ifile3 = -1, -1, -1 
isave = 0

Filename1, Filename2, Filename3 = "", "", ""
Filename = ""
Filesave1, Filesave2, Filesave11, Filesave22 = "", "", "", ""
Grid1, Grid2, Grid3 = "", "", ""
Stati1, Stati2, Stats1, Stats2 = "", "", "", ""
Scali1, Scali2, Scals1, Scals2, Squan1, Squan2 = "", "", "", "", "", ""

dfile1, dfile2, dfile3 = "", "", ""

statwin = hiswin = diswin = diswinm = ""

gcolor = "#E0FFFF"
scolor = dcolor = "#E5E5E5"
qcolor = "#BBFFFF"

col1, col2, col3, col4, col5, col6 = 'red', 'blue', '#9400D3', '#00868B', '#CDCDC1', 'cyan'

gwidth = gheight = ""
swidth = sheight = ""

ltitle = "N       rank         funcs(initial scale)     funcs(sigma)     Nnodes   CCpeak "


#-------------------------------------                           
class APanel(wx.Panel):
    def __init__(self, parent, size, pos):
       wx.Panel.__init__(self, parent, -1, size = size, pos = pos)

#-------------------------------------
class InsertFrame(wx.Frame):
#----------
#mainframe
#----------   
    def __init__(self, parent, id):
        global btnBrowse1, btnBrowse2, btnBrowse3, btnRun1, btnRun2, btnSave
        global tmes, font1, font2, font3, font4, font5, wf1, wf13, hf13, wf14, hf14, wf5, hf5, wfcl
        global wd, hd, wppanel, hppanel, wpar, hpar, bsz
        global hver
   
        (wd, hd) = wx.DisplaySize()   
        wdbase=1440
        hdbase=900

        wpar = hpar = 1.
        if wd >= wdbase : wpar= float(wd)/float(wdbase) 
        if hd >= hdbase : hpar = float(hd)/float(hdbase)

        font1 = wx.Font(10, wx.SWISS, wx.NORMAL, wx.BOLD)
        font2 = wx.Font(11, wx.SWISS, wx.NORMAL, wx.BOLD)
        font3 = wx.Font(12, wx.SWISS, wx.NORMAL, wx.BOLD)
        font4 = wx.Font(10, wx.MODERN, wx.NORMAL, wx.BOLD)
        font5 = wx.Font(10, wx.MODERN, wx.NORMAL, wx.NORMAL)

        dc = wx.ScreenDC()
        dc.SetFont(font1)
        wf1, hf1 = dc.GetTextExtent("1000000.0000")
        wf11, hf11 = dc.GetTextExtent("Browse")
        wf12, hf12 = dc.GetTextExtent("Create scale table")
        wf13, hf13 = dc.GetTextExtent("1.0")
        wf14, hf14 = dc.GetTextExtent("Hist1")
        wf15, hf15 = dc.GetTextExtent("rank scale")
        wfcl, hfcl = dc.GetTextExtent("Close")

        dc.SetFont(font2)
        wf2, hf2 = dc.GetTextExtent("sigma scale  : min,max,ave,rms")
        wf21, hf21 = dc.GetTextExtent("discrepancy function")
        wf22, hf22 = dc.GetTextExtent("save syntheses in rank scale")

        dc.SetFont(font3)
        wf3, hf3 = dc.GetTextExtent("2nd file with the syntheses:")

        dc.SetFont(font5)
        wf5, hf5 = dc.GetTextExtent("cumulative")

        wch = max(wf2, wf3)

        hver = hf21+8
        hver1 = 6
        whor = wch+20
        whor1 = 4*wf1+20
        whor2 = wf1+20
        wbut1 = wf21+40
        wdis = wf1/2+20
        wint = 50

        wtit = 10
        wbrw = whor+whor1+20

        wppanel = whor+whor1+whor2+50
        
        if wppanel < 600: wppanel = 600 
        hppanel = 15*hver+8*hver1+3*wint+2*20+30

        bsz = 80*hpar
        platform = wx.PlatformInfo
        if 'wxGTK' in wx.PlatformInfo: bsz = 50*hpar
        if 'wxMac' in wx.PlatformInfo: bsz = 50*hpar

        titl='Comparison of contour maps. Version 3.2 from 23.08.2016 Authors :  L.Urzhumtseva & A.Urzhumtsev' 
  
        if fstat == 0: 

         print >> fileout, '*** program COMPaRS for comparison of contour maps***'
         print >> fileout, '    calculatioin of the discrepancy function and'
         print >> fileout, '    the rank-based correlation coefficients'
         print >> fileout, '          wxPython version 3.2, August 23, 2016'
         print >> fileout, '         Authors :  L.Urzhumtseva & A.Urzhumtsev'

         xfmain = 10
         yfmain = 20*hpar 
         posmainframe = (xfmain, yfmain)
 
         wx.Frame.__init__(self, None, -1, title=titl, pos=posmainframe, size=(wppanel, hppanel),
          style = wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
         self.CreatePpanel(self)  

        if fstat == 1:   
         wx.Frame.__init__(self, None, -1, title=titl, pos=posmainframe, size=(wppanel, hppanel),
          style = wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX))
         self.CreatePpanel(self) 	 	  	 	 
   	         
# syntheses - file dialog

# file 1

        tit1 = wx.StaticText(self.ppanel, -1, "file with the 1st synthesis:", pos =(wtit,hver1))
        tit1.SetFont(font3)
        tit1.SetForegroundColour(col2)
        inputfile1 = self.inputfile1 = wx.TextCtrl(self.ppanel, 501, Filename1, pos=(whor,hver1), 
                    size=(whor1,hver), style = wx.TE_PROCESS_ENTER)
        inputfile1.SetFont(font1) 
        btnBrowse1 = wx.Button(self.ppanel, -1, "Browse", (wbrw,hver1), (whor2,hver))
        btnBrowse1.SetBackgroundColour(col5)  
        btnBrowse1.SetFont(font1)
        inputfile1.Bind(wx.EVT_KEY_DOWN, self.CleanInf)
        inputfile1.Bind(wx.EVT_TEXT_ENTER, self.Filename1Enter)
        btnBrowse1.Bind(wx.EVT_BUTTON, self.Filename1Browse)

# grid parameters
        tit12 = wx.StaticText(self.ppanel, -1, "grid parameters:", pos =(wtit,hver+2*hver1))
        tit12.SetFont(font2)
        self.grid1 = wx.TextCtrl(self.ppanel, -1, Grid1, pos=(whor,hver+2*hver1), size=(whor1,hver), style = wx.CB_READONLY)     
        self.grid1.SetFont(font1)

# initial scale: min, max, ave, sig
        tit13 = wx.StaticText(self.ppanel, -1, "initial scale  : min,max,ave,rms", pos =(wtit,2*hver+3*hver1))
        tit13.SetFont(font2)
        self.stati1 = wx.TextCtrl(self.ppanel, -1, Stati1, pos=(whor,2*hver+3*hver1), size=(whor1,hver), style = wx.CB_READONLY)     
        self.stati1.SetFont(font1) 
        self.scali1 = wx.TextCtrl(self.ppanel, 100, Scali1, pos=(wbrw,2*hver+3*hver1), size=(whor2,hver), style = wx.TE_PROCESS_ENTER)     
        self.scali1.SetFont(font1)
        self.scali1.Bind(wx.EVT_KEY_DOWN, self.CleanScal)
        self.scali1.Bind(wx.EVT_TEXT_ENTER, self.ScalEnter)

# sigma scale: min, max, ave, sig
        tit14 = wx.StaticText(self.ppanel, -1, "sigma scale  : min,max,ave,rms", pos =(wtit,3*hver+4*hver1))
        tit14.SetFont(font2)
        self.stats1 = wx.TextCtrl(self.ppanel, -1, Stats1, pos=(whor,3*hver+4*hver1), size=(whor1,hver), style = wx.CB_READONLY)     
        self.stats1.SetFont(font1) 
        self.scals1 = wx.TextCtrl(self.ppanel, 110, Scals1, pos=(wbrw,3*hver+4*hver1), size=(whor2,hver), style = wx.TE_PROCESS_ENTER)     
        self.scals1.SetFont(font1)
        titr1 = wx.StaticText(self.ppanel, -1, "rank scale", pos =(wbrw-wf15-30,4*hver+5*hver1))
        titr1.SetFont(font2)
        self.squan1 = wx.TextCtrl(self.ppanel, 120, Squan1, pos=(wbrw,4*hver+5*hver1), size=(whor2,hver), style = wx.TE_PROCESS_ENTER)     
        self.squan1.SetFont(font1)
        self.scals1.Bind(wx.EVT_KEY_DOWN, self.CleanScal)
        self.scals1.Bind(wx.EVT_TEXT_ENTER, self.ScalEnter)
        self.squan1.Bind(wx.EVT_KEY_DOWN, self.CleanScal)
        self.squan1.Bind(wx.EVT_TEXT_ENTER, self.ScalEnter)        

# file 2
        tit2 = wx.StaticText(self.ppanel, -1, "file with the 2nd synthesis:", pos =(wtit,4*hver+4*hver1+wint))
        tit2.SetFont(font3)
        tit2.SetForegroundColour(col2)
        inputfile2 = self.inputfile2 = wx.TextCtrl(self.ppanel, 502, Filename2, pos=(whor,4*hver+4*hver1+wint), 
                    size=(whor1,hver), style = wx.TE_PROCESS_ENTER)
        inputfile2.SetFont(font1) 
        btnBrowse2 = wx.Button(self.ppanel, -1, "Browse", (wbrw,4*hver+4*hver1+wint), (whor2,hver))
        btnBrowse2.SetBackgroundColour(col5)  
        btnBrowse2.SetFont(font1)
        inputfile2.Bind(wx.EVT_KEY_DOWN, self.CleanInf)
        inputfile2.Bind(wx.EVT_TEXT_ENTER, self.Filename2Enter)
        btnBrowse2.Bind(wx.EVT_BUTTON, self.Filename2Browse)

# grid parameters
        tit22 = wx.StaticText(self.ppanel, -1, "grid parameters:", pos =(wtit,5*hver+5*hver1+wint))
        tit22.SetFont(font2)
        self.grid2 = wx.TextCtrl(self.ppanel, -1, Grid2, pos=(whor,5*hver+5*hver1+wint), size=(whor1,hver), style = wx.CB_READONLY)     
        self.grid2.SetFont(font1) 

# initial scale: min, max, ave, sig
        tit23 = wx.StaticText(self.ppanel, -1, "initial scale  : min,max,ave,rms", pos =(wtit,6*hver+6*hver1+wint))
        tit23.SetFont(font2)
        self.stati2 = wx.TextCtrl(self.ppanel, -1, Stati2, pos=(whor,6*hver+6*hver1+wint), size=(whor1,hver), style = wx.CB_READONLY)     
        self.stati2.SetFont(font1) 
        self.scali2 = wx.TextCtrl(self.ppanel, 200, Scali2, pos=(wbrw,6*hver+6*hver1+wint), size=(whor2,hver), style = wx.TE_PROCESS_ENTER)     
        self.scali2.SetFont(font1)
        self.scali2.Bind(wx.EVT_KEY_DOWN, self.CleanScal)
        self.scali2.Bind(wx.EVT_TEXT_ENTER, self.ScalEnter)

# sigma scale: min, max, ave, sig
        tit24 = wx.StaticText(self.ppanel, -1, "sigma scale  : min,max,ave,rms", pos =(wtit,7*hver+7*hver1+wint))
        tit24.SetFont(font2)
        self.stats2 = wx.TextCtrl(self.ppanel, -1, Stats2, pos=(whor,7*hver+7*hver1+wint), size=(whor1,hver), style = wx.CB_READONLY)     
        self.stats2.SetFont(font1)
        self.scals2 = wx.TextCtrl(self.ppanel, 210, Scals2, pos=(wbrw,7*hver+7*hver1+wint), size=(whor2,hver), style = wx.TE_PROCESS_ENTER)     
        self.scals2.SetFont(font1)
        titr2 = wx.StaticText(self.ppanel, -1, "rank scale", pos =(wbrw-wf15-30,8*hver+8*hver1+wint))
        titr2.SetFont(font2)
        self.squan2 = wx.TextCtrl(self.ppanel, 220, Squan2, pos=(wbrw,8*hver+8*hver1+wint), size=(whor2,hver), style = wx.TE_PROCESS_ENTER)     
        self.squan2.SetFont(font1)  
        self.scals2.Bind(wx.EVT_KEY_DOWN, self.CleanScal)
        self.scals2.Bind(wx.EVT_TEXT_ENTER, self.ScalEnter)
        self.squan2.Bind(wx.EVT_KEY_DOWN, self.CleanScal)
        self.squan2.Bind(wx.EVT_TEXT_ENTER, self.ScalEnter)  

# file 3
        tit3 = wx.StaticText(self.ppanel, -1, "file with the mask:", pos =(wtit,8*hver+7*hver1+2*wint))
        tit3.SetFont(font3)
        tit3.SetForegroundColour(col2)
        inputfile3 = self.inputfile3 = wx.TextCtrl(self.ppanel, 503, Filename3, pos=(whor,8*hver+7*hver1+2*wint), 
                    size=(whor1,hver), style = wx.TE_PROCESS_ENTER)
        inputfile3.SetFont(font1) 
        btnBrowse3 = wx.Button(self.ppanel, -1, "Browse", (wbrw,8*hver+7*hver1+2*wint), (whor2,hver))
        btnBrowse3.SetBackgroundColour(col5)  
        btnBrowse3.SetFont(font1)
        inputfile3.Bind(wx.EVT_KEY_DOWN, self.CleanInf)
        inputfile3.Bind(wx.EVT_TEXT_ENTER, self.Filename3Enter)
        btnBrowse3.Bind(wx.EVT_BUTTON, self.Filename3Browse) 
        btnClean3 = wx.Button(self.ppanel, -1, "Clean", (wbrw,9*hver+8*hver1+2*wint), (whor2,hver))
        btnClean3.SetBackgroundColour(col5)  
        btnClean3.SetFont(font1)
        btnClean3.Bind(wx.EVT_BUTTON, self.OnClean)     

# grid parameters
        tit32 = wx.StaticText(self.ppanel, -1, "grid parameters:", pos =(wtit,9*hver+8*hver1+2*wint))
        tit32.SetFont(font2)
        self.grid3 = wx.TextCtrl(self.ppanel, -1, Grid3, pos=(whor,9*hver+8*hver1+2*wint), size=(whor1,hver), style = wx.CB_READONLY)     
        self.grid3.SetFont(font1)     

# run buttons

        tit35 = wx.StaticText(self.ppanel, -1, 'save syntheses in rank scale', pos =(whor,9*hver+8*hver1+3*wint))
        tit35.SetFont(font2)

        btnSave[0] = wx.RadioButton(self.ppanel, -1, 'no', (whor+wf22+20,9*hver+8*hver1+3*wint), (wdis,hver), style = wx.RB_GROUP)
        btnSave[0].SetBackgroundColour(col5)  
        btnSave[0].SetFont(font1)
        btnSave[1] = wx.RadioButton(self.ppanel, -1, 'yes', (whor+wf22+wdis+40,9*hver+8*hver1+3*wint), (wdis,hver))
        btnSave[1].SetBackgroundColour(col5)  
        btnSave[1].SetFont(font1)

        self.Bind(wx.EVT_RADIOBUTTON, self.NonSaveSynt, btnSave[0])
        self.Bind(wx.EVT_RADIOBUTTON, self.OnSaveSynt, btnSave[1])

        btnRun1 = wx.Button(self.ppanel, 600, 'peak correlations', (whor,11*hver+9*hver1+3*wint), (wbut1,hver))
        btnRun1.SetBackgroundColour(col5) 
        btnRun1.SetFont(font2)
        btnRun1.Bind(wx.EVT_BUTTON, self.Quantr)
        btnRun1.Disable()
        self.rank = wx.TextCtrl(self.ppanel, -1, str(qrank), pos=(whor+wbut1+20,11*hver+9*hver1+3*wint), size=(wdis,hver))     
        self.rank.SetFont(font1)
        self.rank.Bind(wx.EVT_KEY_DOWN, self.RankEnter)
        tit33 = wx.StaticText(self.ppanel, -1, 'rank', pos =(whor+wbut1+wdis+40,11*hver+9*hver1+3*wint))
        tit33.SetFont(font2)

        btnRun2 = wx.Button(self.ppanel, 700, 'discrepancy function', (whor,12*hver+11*hver1+3*wint), (wbut1,hver))
        btnRun2.SetBackgroundColour(col5) 
        btnRun2.SetFont(font2)
        btnRun2.Bind(wx.EVT_BUTTON, self.Quantr)
        btnRun2.Disable()
        self.div = wx.TextCtrl(self.ppanel, -1, str(ndfun), pos=(whor+wbut1+20,12*hver+11*hver1+3*wint), size=(wdis,hver))     
        self.div.SetFont(font1)
        self.div.Bind(wx.EVT_KEY_DOWN, self.DivEnter)
        tit34 = wx.StaticText(self.ppanel, -1, 'number of intervals', pos =(whor+wbut1+wdis+40,12*hver+11*hver1+3*wint))
        tit34.SetFont(font2)

# message

        tmes= wx.TextCtrl(self.ppanel, -1, "", pos=(wtit,12*hver+9*hver1+4*wint), size=(wppanel-3*wtit,hver), style = wx.CB_READONLY)
        tmes.SetForegroundColour(col1) 
        tmes.SetFont(font1)
         
        btnExit1=wx.Button(self.ppanel, -1, 'Exit', (0.5*(wppanel-wf11),13*hver+10*hver1+4*wint), (wf11,hver))
        btnExit1.SetBackgroundColour(col5)  
        btnExit1.SetFont(font1)
        btnExit1.Bind(wx.EVT_LEFT_DOWN, self.OnCloseWindow)

        wx.EVT_CLOSE(self, self.OnCloseWindow) 

#-------------------------------------
# Create button panel

    def CreatePpanel(self, parent):
        global ppanel
	  
        ppanel = self.ppanel = APanel(parent, (wppanel,hppanel), (0,0))
        return ppanel

#-------------------------------------
# Enter input file name 1
 
    def Filename1Enter(self, event):
        global fquantr, ifile1, ifile2, ifile3, Filename1, Filename2, Filename3

        fquantr = 0
        ifile1, ifile2, ifile3 = 1, -1, -1
        Filename1, Filename2, Filename3 = "", "", ""

        self.OnBrowse1(self)

#-------------------------------------
# Browse input file name 1
 
    def Filename1Browse(self, event):
        global fquantr, ifile1, ifile2, ifile3, Filename1, Filename2, Filename3

        fquantr = 0
        ifile1, ifile2, ifile3 = 0, -1, -1
        Filename1, Filename2, Filename3 = "", "", ""

        self.OnBrowse1(self) 

#-------------------------------------
# Enter input file name 2
 
    def Filename2Enter(self, event):
        global fquantr, ifile1, ifile2, ifile3, Filename1, Filename2, Filename3
 
        fquantr = 0
        ifile1, ifile2, ifile3 = -1, 1, -1
        Filename1, Filename2, Filename3 = "", "", ""

        self.OnBrowse2(self)

#-------------------------------------
# Browse input file name 2
 
    def Filename2Browse(self, event):
        global fquantr, ifile1, ifile2, ifile3, Filename1, Filename2, Filename3

        fquantr = 0
        ifile1, ifile2, ifile3 = -1, 0, -1
        Filename1, Filename2, Filename3 = "", "", ""

        self.OnBrowse2(self) 

#-------------------------------------
# Enter input file name 3
 
    def Filename3Enter(self, event):
        global fquantr, ifile1, ifile2, ifile3, Filename1, Filename2, Filename3

        fquantr = 0
        ifile1, ifile2, ifile3 = -1, -1, 1
        Filename1, Filename2, Filename3 = "", "", ""

        self.OnBrowse3(self)

#-------------------------------------
# Browse input file name 3
 
    def Filename3Browse(self, event):
        global fquantr, ifile1, ifile2, ifile3, Filename1, Filename2,  Filename3

        fquantr = 0
        ifile1, ifile2, ifile3 = -1, -1, 0
        Filename1, Filename2, Filename3 = "", "", ""

        self.OnBrowse3(self)

#-------------------------------------
# Enter rank value
 
    def RankEnter(self, event):
        global fquantr

        fquantr = 0
        event.Skip()

#-------------------------------------
# Enter number of intervals
 
    def DivEnter(self, event):
        global fquantr

        fquantr = 0
        event.Skip()

#-------------------------------------
# OnBrowse - create open file dialog

    def OnBrowse1(self, evt):
       global dfile1, Filename1

       self.OnClear1(self)
       if flagfile3 != 0: 
         self.OnClear2(self)
         self.OnClear3(self)
       btnBrowse1.SetBackgroundColour(col1)

       if  ifile1 == 0:    
        wildcard = ".xplor files (*.xplor)|*.xplor|"   \
                   ".ccp4 files (*.ccp4)|*.ccp4|"    \
                   ".xplor files (*.xpl)|*.xpl|"   \
                   ".map files (*.map)|*.map|"    \
                   "All files (*.*)|*.*"    

        if dfile1 == "": dDir=os.getcwd()
        else: dDir=dfile1
        dlg1 = wx.FileDialog(
            self, message="Choose a file",
            defaultDir=dDir, 
            defaultFile="",
            wildcard=wildcard,
            style=wx.OPEN
            )             
        if dlg1.ShowModal() == wx.ID_OK:
            pth = dlg1.GetPath()
            dfile1 = dlg1.GetDirectory()
            self.inputfile1.ChangeValue(pth)
            dlg1.Destroy()
            Filename1 = self.inputfile1.GetValue()
            Filename1 = Filename1.strip()

       if  ifile1 == 1:

        fn = self.inputfile1.GetValue()
        fn = fn.strip() 
        if os.path.isfile(fn):
          Filename1 = fn 
        else: 
          tmes.SetValue(" No such file or directory : " + fn)
          return

       print >> fileout, ' '
       print >> fileout, 'file name of the 1st syntheses :'
       print >> fileout, Filename1

       self.CompSynt(self) 

       btnBrowse1.SetBackgroundColour(col5) 

#-------------------------------------
# Clear all for file 1

    def OnClear1(self, evt):
       global flagfile1, ffile1, Grid1
       global Stati1, Stats1, Scali1, Scals1, Squan1, dfile1

       flagfile1 = 0
       ffile1 = 0

       Grid1 = ""
       Stati1 = ""
       Stats1 = ""
       Scali1 = ""
       Scals1 = ""
       Squan1 = ""
       dfile1 = ""

       self.grid1.SetValue("")
       self.stati1.SetValue("")
       self.stats1.SetValue("")
       self.scali1.SetValue("")
       self.scals1.SetValue("")
       self.squan1.SetValue("")
        
       if hiswin : hiswin.Destroy() 
       if diswin : diswin.Destroy()
       if diswinm : diswinm.Destroy()

       btnRun1.Disable()
       btnRun2.Disable()

       self.CleanMes(evt) 

#-------------------------------------
# OnBrowse - create open file dialog

    def OnBrowse2(self, evt):
       global dfile2, Filename2

       self.OnClear2(self)
       if flagfile3 != 0: 
         self.OnClear1(self)
         self.OnClear3(self)
       btnBrowse2.SetBackgroundColour(col1)

       if  ifile2 == 0:  
        wildcard = ".xplor files (*.xplor)|*.xplor|"   \
                   ".ccp4 files (*.ccp4)|*.ccp4|"    \
                   ".xplor files (*.xpl)|*.xpl|"   \
                   ".map files (*.map)|*.map|"    \
                   "All files (*.*)|*.*"     

        if dfile2 == "": dDir=os.getcwd()
        else: dDir=dfile2
        dlg2 = wx.FileDialog(
            self, message="Choose a file",
            defaultDir=dDir, 
            defaultFile="",
            wildcard=wildcard,
            style=wx.OPEN
            ) 
                  
        if dlg2.ShowModal() == wx.ID_OK:
            pth = dlg2.GetPath()
            dfile2 = dlg2.GetDirectory()
            self.inputfile2.ChangeValue(pth)
            dlg2.Destroy()
            Filename2 = self.inputfile2.GetValue()
            Filename2 = Filename2.strip() 

       if  ifile2 == 1:

        fn = self.inputfile2.GetValue()
        fn = fn.strip() 
        if os.path.isfile(fn):
          Filename2 = fn 
        else: 
          tmes.SetValue(" No such file or directory : " + fn)
          return

       print >> fileout, ' '
       print >> fileout, 'file name of the 2nd syntheses :'
       print >> fileout, Filename2

       self.CompSynt(self)
       btnBrowse2.SetBackgroundColour(col5) 

#-------------------------------------
# Clear all for file 2

    def OnClear2(self, evt):
       global flagfile2, ffile2, Grid2
       global Stati2, Stats2, Scali2, Scals2, Squan2, dfile2

       flagfile2 = 0
       ffile2 = 0

       Grid2 = ""
       Stati2 = ""
       Stats2 = ""
       Scali2 = ""
       Scals2 = ""
       Squan2 = ""
       dfile2 = ""

       self.grid2.SetValue("")
       self.stati2.SetValue("")
       self.stats2.SetValue("")
       self.scali2.SetValue("")
       self.scals2.SetValue("")
       self.squan2.SetValue("")
         
       if hiswin : hiswin.Destroy() 
       if diswin : diswin.Destroy()
       if diswinm : diswinm.Destroy()

       btnRun1.Disable()
       btnRun2.Disable()

       self.CleanMes(evt) 
  
#-------------------------------------
# OnBrowse - create open file dialog

    def OnBrowse3(self, evt):
       global iclean, dfile3, Filename3

       self.OnClear3(self)
       btnBrowse3.SetBackgroundColour(col1)

       iclean = 0

       if flagfile1 == 0: 
          tmes.SetValue("Empty file 1")
          btnBrowse3.SetBackgroundColour(col5) 
          return
       if flagfile2 == 0: 
          tmes.SetValue("Empty file 2")
          btnBrowse3.SetBackgroundColour(col5) 
          return

       if  ifile3 == 0:  
        wildcard = ".xplor files (*.xplor)|*.xplor|"   \
                   ".ccp4 files (*.ccp4)|*.ccp4|"    \
                   ".xplor files (*.xpl)|*.xpl|"   \
                   ".map files (*.map)|*.map|"    \
                   "All files (*.*)|*.*"     

        if dfile3 == "": dDir=os.getcwd()
        else: dDir=dfile3
        dlg3 = wx.FileDialog(
            self, message="Choose a file",
            defaultDir=dDir, 
            defaultFile="",
            wildcard=wildcard,
            style=wx.OPEN
            )                
        if dlg3.ShowModal() == wx.ID_OK:
            pth = dlg3.GetPath()
            dfile3 = dlg3.GetDirectory()
            self.inputfile3.ChangeValue(pth)
            dlg3.Destroy()
            Filename3 = self.inputfile3.GetValue()
            Filename3 = Filename3.strip() 

       if  ifile3 == 1:

        fn = self.inputfile3.GetValue()
        fn = fn.strip() 
        if os.path.isfile(fn):
          Filename3 = fn 
        else: 
          tmes.SetValue(" No such file or directory : " + fn)
          return

       self.CompSynt(self) 
       btnBrowse3.SetBackgroundColour(col5) 

#-------------------------------------
# Clear all for file 3

    def OnClear3(self, evt):
       global flagfile3, ffile3, Grid3, dfile3, Filename3

       if hiswin : hiswin.Destroy() 
       if diswinm : diswinm.Destroy()

       flagfile3 = 0
       ffile3 = 0
       Filename3 = ""
       Grid3 = ""
       dfile3 = ""

       self.grid3.SetValue("")
       self.inputfile3.SetValue("")
       self.stati1.SetValue("")
       self.stats1.SetValue("")
       self.scali1.SetValue("")
       self.scals1.SetValue("")
       self.squan1.SetValue("")
       self.stati2.SetValue("")
       self.stats2.SetValue("")
       self.scali2.SetValue("")
       self.scals2.SetValue("")
       self.squan2.SetValue("")
         
       btnRun1.Disable()
       btnRun2.Disable()

       self.CleanMes(evt) 
       return

#-------------------------------------
# Clear Scali, Scals, Squan

    def CleanScal(self, evt):
       global Scali1, Scals1, Squan1, Scali2, Scals2, Squan2

       id = evt.GetId()
       self.CleanMes(evt) 
    
       if id == 100:
        Scals1 = ""
        Squan1 = ""
        self.scals1.SetValue("")
        self.squan1.SetValue("")
       if id == 110:
        Scali1 = ""
        Squan1 = ""
        self.scali1.SetValue("")
        self.squan1.SetValue("")
       if id == 120:
        Scali1 = ""
        Scals1 = ""
        self.scali1.SetValue("")
        self.scals1.SetValue("")

       if id == 200:
        Scals2 = ""
        Squan2 = ""
        self.scals2.SetValue("")
        self.squan2.SetValue("")
       if id == 210:
        Scali2 = ""
        Squan2 = ""
        self.scali2.SetValue("")
        self.squan2.SetValue("")
       if id == 220:
        Scali2 = ""
        Scals2 = ""
        self.scali2.SetValue("")
        self.scals2.SetValue("")

       evt.Skip()

#-------------------------------------
# Clear Scali, Scals, Squan

    def CleanInf(self, evt):
       global flagfile1, ffile1, dfile1, Grid1, Stati1, Stats1
       global flagfile2, ffile2, dfile2, Grid2, Stati2, Stats2
       global flagfile3, ffile3, dfile3, Grid3
       global Scali1, Scals1, Squan1, Scali2, Scals2, Squan2

       tmes.SetValue("")

       id = evt.GetId()
       key = evt.GetKeyCode()

       if key != wx.WXK_RIGHT and key != wx.WXK_LEFT:
    
        if id == 501:

          self.OnClear1(self)
          if flagfile3 != 0: 
            self.OnClear2(self)
            self.OnClear3(self)

        if id == 502:

          self.OnClear2(self)
          if flagfile3 != 0: 
            self.OnClear1(self)
            self.OnClear3(self)

        if id == 503: self.OnClear3(self)

       evt.Skip()

#-------------------------------------
# Enter scale coefficients
       
    def ScalEnter(self, evt):
       global Scals1, Scals11, Scals2, Scals21, Squan1, Squan11, Squan2, Squan21

       tmes.SetValue("")

       id = evt.GetId()
    
       if flagfile1 != 0 and flagfile2 != 0 and flagfile3 == 0:
        drho1 = (fmax11-fmin11)/mhis
        drho2 = (fmax21-fmin21)/mhis
        if id == 100: 
           try:
             f1 = float(self.scali1.GetValue()) 
           except ValueError:
             tmes.SetValue(" Wrong symbol in the initial scale")
             return 
           if f1 <= fminp11: f1 = fminp11        
           if f1 >= fmaxp11: f1 = fmaxp11
           rho1 = float(f1-favep11)/fsigmap11
           k1 = int((rho1-fmin11)/drho1)
           if k1 <mhis-2:
             rhok1 = fmin11+k1*drho1
             q1 = chist1[k1]+(chist1[k1+1]-chist1[k1])*(rho1-rhok1)/drho1 
           else: q1 = chist1[mhis-1]

           Scals1 = rho1
           Squan1 = q1

        if id == 110:
           try:     
             rho1 = float(self.scals1.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the sigma scale")
             return 
           if rho1 <= fmin11: rho1 = fmin11          
           if rho1 >= fmax11: rho1 = fmax11
           f1 = rho1*fsigmap11+favep11
           k1 = int((rho1-fmin11)/drho1)
           if k1 <mhis-2:
            rhok1 = fmin11+k1*drho1
            q1 = chist1[k1]+(chist1[k1+1]-chist1[k1])*(rho1-rhok1)/drho1
           else: q1 = chist1[mhis-1] 

           Scals1 = rho1
           Squan1 = q1

        if id == 120: 
           try:    
             q1 = float(self.squan1.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the rank value")
             return 
           if q1 <= chist1[0]: q1 = chist1[0]        
           if q1 >= chist1[mhis-1]: 
              q1 = chist1[mhis-1]
              rho1 = fmax11 

           for m in xrange(mhis-2):
             if q1 >= chist1[m] and q1 < chist1[m+1]: 
               rho1 = fmin11+m*drho1+drho1*(q1-chist1[m])/(chist1[m+1]-chist1[m])
           f1 = rho1*fsigmap11+favep11

           Scals1 = rho1
           Squan1 = q1

        if id == 200: 
           try:  
             f2 = float(self.scali2.GetValue()) 
           except ValueError:
             tmes.SetValue(" Wrong symbol in the initial scale")
             return 
           if f2 <= fminp21: f2 = fminp21          
           if f2 >= fmaxp21: f2 = fmaxp21
           rho2 = float(f2-favep21)/fsigmap21
           k2 = int((rho2-fmin21)/drho2)
           if k2 <mhis-2:
            rhok2 = fmin21+k2*drho2
            q2 = chist2[k2]+(chist2[k2+1]-chist2[k2])*(rho2-rhok2)/drho2 
           else: q2 = chist2[mhis-1]

           Scals2 = rho2
           Squan2 = q2

        if id == 210:
           try:   
             rho2 = float(self.scals2.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the sigma scale")
             return 
           if rho2 <= fmin21: rho2 = fmin21          
           if rho2 >= fmax21: rho2 = fmax21
           f2 = rho2*fsigmap21+favep21
           k2 = int((rho2-fmin21)/drho2)
           if k2 <mhis-2: 
            rhok2 = fmin21+k2*drho2
            q2 = chist2[k2]+(chist2[k2+1]-chist2[k2])*(rho2-rhok2)/drho2 
           else: q2 = chist2[mhis-1] 

           Scals2 = rho2
           Squan2 = q2

        if id == 220: 
           try:    
             q2 = float(self.squan2.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the rank value")
             return 
           if q2 <= chist2[0]: q2 = chist2[0]        
           if q2 >= chist2[mhis-1]: 
              q2 = chist2[mhis-1]
              rho2 = fmax21 

           for m in xrange(mhis-2):
             if q2 >= chist2[m] and q2 < chist2[m+1]: 
               rho2 = fmin21+m*drho2+drho2*(q2-chist2[m])/(chist2[m+1]-chist2[m])
           f2 = rho2*fsigmap21+favep21

           Scals2 = rho2
           Squan2 = q2

       if flagfile1 != 0 and flagfile2 != 0 and flagfile3 != 0:
        drho1 = (fmax1-fmin1)/mhis
        drho2 = (fmax2-fmin2)/mhis

        if id == 100: 
           try:  
             f1 = float(self.scali1.GetValue()) 
           except ValueError:
             tmes.SetValue(" Wrong symbol in the initial scale")
             return 
           if f1 <= fminp1: f1 = fminp1        
           if f1 >= fmaxp1: f1 = fmaxp1
           rho1 = float(f1-favep1)/fsigmap1
           k1 = int((rho1-fmin1)/drho1)
           if k1 <mhis-2:
             rhok1 = fmin1+k1*drho1
             q1 = chist1m[k1]+(chist1m[k1+1]-chist1m[k1])*(rho1-rhok1)/drho1 
           else: q1 = chist1m[mhis-1]

           Scals11 = rho1
           Squan11 = q1

        if id == 110:
           try:   
             rho1 = float(self.scals1.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the sigma scale")
             return 
           if rho1 <= fmin1: rho1 = fmin1         
           if rho1 >= fmax1: rho1 = fmax1
           f1 = rho1*fsigmap1+favep1
           k1 = int((rho1-fmin1)/drho1)
           if k1 <mhis-2:
            rhok1 = fmin1+k1*drho1
            q1 = chist1m[k1]+(chist1m[k1+1]-chist1m[k1])*(rho1-rhok1)/drho1
           else: q1 = chist1m[mhis-1] 

           Scals11 = rho1
           Squan11 = q1

        if id == 120: 
           try:    
             q1 = float(self.squan1.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the rank value")
             return 
           if q1 <= chist1m[0]: q1 = chist1m[0]        
           if q1 >= chist1m[mhis-1]: 
              q1 = chist1m[mhis-1]
              rho1 = fmax1 

           for m in xrange(mhis-2):
             if q1 >= chist1m[m] and q1 < chist1m[m+1]: 
               rho1 = fmin1+m*drho1+drho1*(q1-chist1m[m])/(chist1m[m+1]-chist1m[m])
           f1 = rho1*fsigmap1+favep1

           Scals11 = rho1
           Squan11 = q1

        if id == 200: 
           try:  
             f2 = float(self.scali2.GetValue()) 
           except ValueError:
             tmes.SetValue(" Wrong symbol in the initial scale")
             return 
           if f2 <= fminp2: f2 = fminp2          
           if f2 >= fmaxp2: f2 = fmaxp2
           rho2 = float(f2-favep2)/fsigmap2
           k2 = int((rho2-fmin2)/drho2)
           if k2 <mhis-2:
            rhok2 = fmin2+k2*drho2
            q2 = chist2m[k2]+(chist2m[k2+1]-chist2m[k2])*(rho2-rhok2)/drho2 
           else: q2 = chist2m[mhis-1]

           Scals21 = rho2
           Squan21 = q2

        if id == 210:
           try:   
             rho2 = float(self.scals2.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the sigma scale")
             return 
           if rho2 <= fmin2: rho2 = fmin2          
           if rho2 >= fmax2: rho2 = fmax2
           f2 = rho2*fsigmap2+favep2
           k2 = int((rho2-fmin2)/drho2)
           if k2 <mhis-2: 
            rhok2 = fmin2+k2*drho2
            q2 = chist2m[k2]+(chist2m[k2+1]-chist2m[k2])*(rho2-rhok2)/drho2 
           else: q2 = chist2m[mhis-1] 

           Scals21 = rho2
           Squan21 = q2

        if id == 220: 
           try:    
             q2 = float(self.squan2.GetValue())
           except ValueError:
             tmes.SetValue(" Wrong symbol in the rank value")
             return 
           if q2 <= chist2m[0]: q2 = chist2m[0]        
           if q2 >= chist2m[mhis-1]: 
              q2 = chist2m[mhis-1]
              rho2 = fmax2 

           for m in xrange(mhis-2):
             if q2 >= chist2m[m] and q2 < chist2m[m+1]: 
               rho2 = fmin2+m*drho2+drho2*(q2-chist2m[m])/(chist2m[m+1]-chist2m[m])
           f2 = rho2*fsigmap2+favep2

           Scals21 = rho2
           Squan21 = q2

       if flagfile1 != 0 and flagfile2 != 0 and (id == 100 or id == 110 or id == 120): 

        if f1 < meps: tsc = str("%12.4f" %f1)
        else: tsc = str("%12.2e" %f1)
        self.scali1.SetValue(tsc)
        if rho1 < meps: tsc = str("%12.4f" %rho1)
        else: tsc = str("%12.2e" %rho1)
        self.scals1.SetValue(tsc)
        self.squan1.SetValue(str("%12.4f" %q1)) 

        if hiswin: hiswin.Refresh()       

       if flagfile1 != 0 and flagfile2 != 0 and (id == 200 or id == 210 or id == 220): 

         if f2 < meps: tsc = str("%12.4f" %f2)
         else: tsc = str("%12.2e" %f2)
         self.scali2.SetValue(tsc)
         if rho2 < meps: tsc = str("%12.4f" %rho2)
         else: tsc = str("%12.2e" %rho2)
         self.scals2.SetValue(tsc)
         self.squan2.SetValue(str("%12.4f" %q2))

         if hiswin: hiswin.Refresh()

#-------------------------------------
# Clean

    def OnClean(self, evt):
       global iclean, fquantr, flagfile3, ffile3, Filename3, Grid3, dfile3, hwin

       error_mes = tmes.GetValue()  

       if flagfile3 == 0 and not error_mes: return     

       hwin = wwin/2
       if hiswin: hiswin.Refresh()    
       if diswinm : diswinm.Destroy()

       if flagfile3 != 0:  
         self.stati1.SetValue(Stati1)
         self.stati2.SetValue(Stati2)
         self.stats1.SetValue(Stats1)
         self.stats2.SetValue(Stats2)
         self.scali1.SetValue(Scali1)
         self.scali2.SetValue(Scali2)
         self.scals1.SetValue(Scals1)
         self.scals2.SetValue(Scals2)
         self.squan1.SetValue(Squan1)
         self.squan2.SetValue(Squan2)

       if flagfile1 != 0 and flagfile2 != 0:
         btnRun1.Enable()
         btnRun2.Enable()

       iclean = 1
       fquantr = 0

       flagfile3 = 0
       ffile3 = 0
       Filename3 = ""
       Grid3 = ""
       dfile3 = ""

       self.inputfile3.SetValue("")
       self.grid3.SetValue("")

       self.CleanMes(evt) 
       return

#-------------------------------------
# Comparison of the two syntheses
    def CompSynt(self, evt):
       
       global Grid1, Grid2
       global ffile1, ffile2, ffile3
       global Stati, Stats, Scali, Scals   
       global Stati1, Stati11, Stati2, Stati21, Stats1, Stats11, Stats2, Stats21
       global Scali1, Scali11, Scali2, Scali21, Scals1, Scals11, Scals2, Scals21
       global Squan1, Squan11, Squan2, Squan21
       global fminp, fmaxp, favep, fsum, fsum2  
       global fmin1, fmax1, fave1, fsigma1, fmin2, fmax2, fave2, fsigma2
       global fminp1, fmaxp1, fminp2, fmaxp2, favep1, fsigmap1, favep2, fsigmap2
       global fmin11, fmax11, fave11, fsigma11, fmin21, fmax21, fave21, fsigma21
       global fminp11, fmaxp11, fminp21, fmaxp21, favep11, fsigmap11, favep21, fsigmap21
       global corrn, corrc, corrsn, corrsc
       global corrn1, corrc1, corrsn1, corrsc1
       global khis1, khis2, chis1, chis2, chist1, chist2, hiswin
       global khis1m, khis2m, chis1m, chis2m, chist1m, chist2m
       global filemap1, filemap2, filemap3, flagfile1, flagfile2, flagfile3
       global fmsz1, fmsz2, fmsz3
       global isave, isec, nstr, nsmc, nsec, ntot, sumtot
       global sum1, sum2, sum11, sum22, sum12, mfun11, mfun22, mfun12
       global vmap1, vmap2, vmap3
       global mvmap1m, mvmap2m, minc1m, minc2m, maxc1m, maxc2m
       global fminp1m, fminp2m, fmaxp1m, fmaxp2m
       global fsum1m, fsum2m, fsum21m, fsum22m, fdifp1m, fdifp2m
        
       fminp, fmaxp, favep, fsum, fsum2, fsum12 = [], [], [], [], [], []
       fminp1m, fminp2m, fmaxp1m, fmaxp2m = [], [], [], []
       fsum1m, fsum2m, fsum21m, fsum22m, fdifp1m, fdifp2m = [], [], [], [], [], []
       fsum1s, fsum2s, fsum11s, fsum22s, fsum12s  = [], [], [], [], []

       fl1 = self.inputfile1.GetValue()
       fl2 = self.inputfile2.GetValue()
       fl3 = self.inputfile3.GetValue()
  
       if fl1 != "" and fl2 != ""  and fl3 != "" and (fl1 == fl3 or fl2 == fl3): 
         tmes.SetValue(" Wrong mask file")
         return

       error_mes = tmes.GetValue()  
       if not error_mes: 
# .ccp4 file? 
         self.Read_ccp4(self) 

       error_mes = tmes.GetValue()  
       if not error_mes: 

# .xplor file?
        if ftype == 0: self.Read_xplor(self)

       error_mes = tmes.GetValue()  
       if error_mes: return

       nsec = ma*mb
       nsmc = nsec*mc

       if nsmc <= lmem: ntot = nsmc
       else: ntot = nsec
                
# read density matrix 

       if nsec*mc == ntot: nstr = 1
       if nsec*mc > ntot: nstr = mc

       for isec in xrange(nstr):    

        if flagfile3 == 0:
  
         if ftype == 1: 
           self.Readm_ccp4(filemap,ntot) 
           error_mes = tmes.GetValue()  
           if error_mes: return 
       
         else: 
           self.Readm_xpl(filemap,ma,mb,mc)
           error_mes = tmes.GetValue()  
           if error_mes: return

         if isec == 0 and ifile1 != -1: vmap1 = vmap
         if isec == 0 and ifile2 != -1: vmap2 = vmap
           
         mvmap = mean(vmap)
         minc = min(vmap)
         maxc = max(vmap)
         fminp.append(minc)
         fmaxp.append(maxc)
         favep.append(mvmap)
         fsum.append(sum(vmap))
         fsum2.append(sum(vmap*vmap))
     
       if ifile1 != -1: flagfile1 = 1
       if ifile2 != -1: flagfile2 = 1
       if ifile3 != -1: 
         flagfile3 = 1
         isave = 0
         btnSave[0].SetValue(True)
         btnSave[1].SetValue(False)

# ---calcul for the 1st file---

       if flagfile1 != 0 and ffile1 == 0: 
    
        filemap1 = filemap
        if ftype == 1: fmsz1 = fmsz

        flagfile1 = 2
        Grid1 = str(Grid)
        self.grid1.SetValue(Grid1)

# scaling in standard deviations (sigma)

        error_mes = tmes.GetValue()  
        if not error_mes: 
          ffile1 = 1
          print >> fileout, ' '
          print >> fileout, ' function 1 : statistics'

          self.ScaSig(nsmc) 

          fmin1 = fmin11 = fmin
          fmax1 = fmax11 = fmax
          fave1 = fave11 = fave
          fsigma1 = fsigma11 = fsigma
          fminp1 = fminp11 = fminp
          fmaxp1 = fmaxp11 = fmaxp
          favep1 = favep11 = favep
          fsigmap1 = fsigmap11 = fsigmap  
          sum1 = sum11 = sump
          mfun11 = mfun111 = mfunp    
 
          Stati1 = str(Stati)
          Stats1 = str(Stats)
          self.stati1.SetValue(Stati1)
          self.stats1.SetValue(Stats1)
  
          Scali1 = str(Scali)
          Scals1 = str(Scals)        
          self.scali1.SetValue(Scali1)
          self.scals1.SetValue(Scals1)

# ---calcul for the 2nd file---

       if flagfile2 != 0 and ffile2 == 0:

        filemap2 = filemap
        if ftype == 1: fmsz2 = fmsz

        flagfile2 = 2
        Grid2 = str(Grid)
        self.grid2.SetValue(Grid2)

# scaling in standard deviations (sigma)

        error_mes = tmes.GetValue()  
        if not error_mes:
          ffile2 = 1
          print >> fileout, ' '
          print >> fileout, ' function 2 : statistics' 

          self.ScaSig(nsmc) 

          fmin2 = fmin21 = fmin
          fmax2 = fmax21 = fmax
          fave2 = fave21 = fave
          fsigma2 = fsigma21 = fsigma
          fminp2 = fminp21 = fminp
          fmaxp2 = fmaxp21 = fmaxp
          favep2 = favep21 = favep
          fsigmap2 = fsigmap21 = fsigmap   
          sum2 = sump
          mfun22 = mfunp   

          Stati2 = str(Stati)
          Stats2 = str(Stats)
          self.stati2.SetValue(Stati2)
          self.stats2.SetValue(Stats2)

          Scali2 = str(Scali)
          Scals2 = str(Scals)
          self.scali2.SetValue(Scali2)
          self.scals2.SetValue(Scals2)

# ---calcul for the 1st and 2nd file---

       if flagfile1 != 0 and flagfile2 != 0 and flagfile3 == 0:

# control of data
        error_mes = tmes.GetValue()  
        if not error_mes: 
         if Grid1 != Grid2:
          tmes.SetValue("Grids for the functions are different: " + Grid1 + " and "+ Grid2)
          return 
        
        khis1 = zeros(mhis) 
        chis1 = zeros(mhis)
        skhis1 = zeros(shis)
        schis1 = zeros(shis)

        khis2 = zeros(mhis) 
        chis2 = zeros(mhis)
        skhis2 = zeros(shis)
        schis2 = zeros(shis)

        if nstr != 1 or hiswin !="":

# 2nd read of sections

         filemap1.seek(0)
         filemap2.seek(0)

         if ftype == 1:
          lin = filemap1.read(fmsz1)
          lin = filemap2.read(fmsz2)
         else: 
          for i in xrange(nlin):
           lin = filemap1.readline()
           lin = filemap2.readline()

        dhis1 = float(fmax1-fmin1)/float(mhis)
        dhis2 = float(fmax2-fmin2)/float(mhis)

        for isec in xrange(nstr):

          if nstr != 1 or hiswin != "":  
 
           if ftype == 1: 
            self.Readm_ccp4(filemap1,ntot)
            vmap1 = vmap
            self.Readm_ccp4(filemap2,ntot)
            vmap2 = vmap
           else: 
            self.Readm_xpl(filemap1,ma,mb,mc)
            vmap1 = vmap
            self.Readm_xpl(filemap2,ma,mb,mc)
            vmap2 = vmap          

          fsum12.append(sum(vmap1*vmap2))

# functions rescaling in sigmas

          vmap1 = (vmap1-favep1)/fsigmap1
          vmap2 = (vmap2-favep2)/fsigmap2

          fsum1s.append(sum(vmap1))
          fsum2s.append(sum(vmap2))
          fsum11s.append(sum(vmap1*vmap1))
          fsum22s.append(sum(vmap2*vmap2))
          fsum12s.append(sum(vmap1*vmap2))

# calcul of histograms 
      
          di = vmap1-fmin1

          jhis1 = (di/dhis1).astype(int)
          jhis1 = np.where(jhis1 <= mhis-1, jhis1, mhis-1)

          di = vmap2-fmin2

          jhis2 = (di/dhis2).astype(int) 
          jhis2 = np.where(jhis2 <= mhis-1, jhis2, mhis-1)
 
          for i in xrange(len(vmap)):
            khis1[jhis1[i]] = khis1[jhis1[i]]+1 
            khis2[jhis2[i]] = khis2[jhis2[i]]+1 

        ahis1 = khis1/nsmc
        ahis2 = khis2/nsmc

        chis1[0] = ahis1[0]
        chis2[0] = ahis2[0]

        for i in xrange(1,mhis):
         chis1[i] = chis1[i-1]+ahis1[i]
         chis2[i] = chis2[i-1]+ahis2[i]

        chis1 = np.where(chis1 <= 1.0, chis1, 1.0)
        chis2 = np.where(chis2 <= 1.0, chis2, 1.0)

        ms = int(mhis)/int(shis)
        if mhis-ms*shis > 0: ms = ms+1

        for j in xrange(1,shis):
         for i in xrange(mhis):
          if i >= ms*(j-1) and i < ms*j: 
              skhis1[j] = skhis1[j]+khis1[i]
              schis1[j] = schis1[j]+chis1[i]
              skhis2[j] = skhis2[j]+khis2[i]
              schis2[j] = schis2[j]+chis2[i]

        rho = 0.

        k = int((rho-fmin1)/dhis1)
        rhok = fmin1+k*dhis1  
        q = chis1[k]+(chis1[k+1]-chis1[k])*(rho-rhok)/dhis1 
        Squan = "%12.4f" %q
        Squan1 = str(Squan)
        self.squan1.SetValue(Squan1)

        k = int((rho-fmin2)/dhis2)
        rhok = fmin2+k*dhis2  
        q = chis2[k]+(chis2[k+1]-chis2[k])*(rho-rhok)/dhis2 
        Squan = "%12.4f" %q
        Squan2 = str(Squan)
        self.squan2.SetValue(Squan2)

        khis1 = skhis1
        chist1 = chis1  
        chis1 = schis1

        khis2 = skhis2
        chist2 = chis2
        chis2 = schis2

        mfun12 = sum(fsum12)

        sum1s = sum(fsum1s)
        sum2s = sum(fsum2s)
        mfun11s = sum(fsum11s)
        mfun22s = sum(fsum22s)
        mfun12s = sum(fsum12s)

# correlation : initial scale 

        error_mes = tmes.GetValue()  
        if not error_mes:
            self.Scorr(sum1,sum2,mfun11,mfun22,mfun12,nsmc)  
            corrn = corrn1 = crn
            corrc = corrc1 = crc

# correlation : sigma scale

        error_mes = tmes.GetValue()  
        if not error_mes: 
            self.Scorr(sum1s,sum2s,mfun11s,mfun22s,mfun12s,nsmc)
            corrsn = corrsn1 = crn
            corrsc = corrsc1 = crc 

# histogram 1 and 2 file
        error_mes = tmes.GetValue()  
        if not error_mes:  
            hiswin = Hist_Graph(self)

# ---calcul for the 1st, 2nd, 3rd files---

       if flagfile1 != 0 and flagfile2 != 0 and flagfile3 != 0:

        sumtot = 0

        if ftype == 1: fmsz3 = fmsz

        if nstr != 1 or hiswin != "":

         filemap1.seek(0)
         filemap2.seek(0)

         if ftype == 1:
          lin = filemap1.read(fmsz1)
          lin = filemap2.read(fmsz2)
         else: 
          for i in xrange(nlin):
           lin = filemap1.readline()
           lin = filemap2.readline()

        filemap3 = filemap
        flagfile3 = 2
        isave = 0
        btnSave[0].SetValue(True)
        btnSave[1].SetValue(False)

        for isec in xrange(nstr):  
 
          if ftype == 1: 
           if nstr != 1 or hiswin != "":
            self.Readm_ccp4(filemap1,ntot)
            vmap1 = vmap
            self.Readm_ccp4(filemap2,ntot)
            vmap2 = vmap
           self.Readm_ccp4(filemap3,ntot)
           vmap3 = vmap
          else: 
           if nstr != 1 or hiswin != "":
            self.Readm_xpl(filemap1,ma,mb,mc)
            vmap1 = vmap
            self.Readm_xpl(filemap2,ma,mb,mc)
            vmap2 = vmap          
           self.Readm_xpl(filemap3,ma,mb,mc)
           vmap3 = vmap

          self.Selmsk()

          if nstr == 1 and hiswin == "": 
           vmap1 = vmap1*fsigmap1+favep1
           vmap2 = vmap2*fsigmap2+favep2

          sumtot = sumtot+mtot

          if len(vmap1) != 0:

              mvmap1m = mean(vmap1)
              mvmap2m = mean(vmap2)
              minc1m = min(vmap1)
              minc2m = min(vmap2)
              maxc1m = max(vmap1)
              maxc2m = max(vmap2)
              fminp1m.append(minc1m)
              fminp2m.append(minc2m)
              fmaxp1m.append(maxc1m)
              fmaxp2m.append(maxc2m)
              fsum1m.append(sum(vmap1))
              fsum2m.append(sum(vmap2))
              fsum21m.append(sum(vmap1*vmap1))
              fsum22m.append(sum(vmap2*vmap2))
              fdifp1m.append(vmap1-mvmap1m) 
              fdifp2m.append(vmap2-mvmap2m) 

          if isec == nstr-1: print >> fileout, 'mask selection :' + "%10i" %sumtot + ' from' + "%10i" %nsmc + ' grid nodes have been selected' 

# scaling in standard deviations (sigma)

        error_mes = tmes.GetValue()  
        if not error_mes: 
          print >> fileout, ' '
          print >> fileout, ' function 1 : statistics'

          fminp1 = min(fminp1m)
          fmaxp1 = max(fmaxp1m)
          favep1 = sum(fsum1m)/sumtot
          sum1 = sum(fsum1m)
          mfun11 = sum(fsum21m)       

          dsqp = mfun11-2*favep1*sum1+sumtot*favep1*favep1
          fsigp = dsqp/sumtot
          fsigmap1 = np.sqrt(fsigp)

          print >> fileout, ' initial scale: min,max,ave,sq,sig' + "%9.4f" %fminp1 + "%9.4f" %fmaxp1 + "%9.4f" %favep1 + "%9.4f" %fsigp + "%9.4f" %fsigmap1
          Stati = "%12.4f" %fminp1 + "%12.4f" %fmaxp1 + "%12.4f" %favep1 + "%12.4f" %fsigmap1

# file1 - after normalization

          fmin1 = (fminp1-favep1)/fsigmap1
          fmax1 = (fmaxp1-favep1)/fsigmap1
          fave1 = 0.

          fs2 = fsigmap1*fsigmap1
          dsq = dsqp-2*fave1*fsigmap1*(sum1-sumtot*favep1)+sumtot*fave1*fave1*fs2
          dsq= dsq/fs2
          fsig = dsq/sumtot
          fsigma1 = np.sqrt(fsig)

          print >> fileout, ' sigma scale  : min,max,ave,sq,sig' + "%9.4f" %fmin1 + "%9.4f" %fmax1 + "%9.4f" %fave1 + "%9.4f" %fsig + "%9.4f" %fsigma1
          Stats = "%12.4f" %fmin1 + "%12.4f" %fmax1 + "%12.4f" %fave1 + "%12.4f" %fsigma1

          rho = 0.
          f = rho*fsigmap1+favep1
          if f < meps: Scali = "%12.4f" %f
          else: Scali = "%12.2e" %f
          if rho < meps: Scals = "%12.4f" %rho
          else: Scals = "%12.2e" %rho

          Stati11 = str(Stati)
          Stats11 = str(Stats)
          self.stati1.SetValue(Stati11)
          self.stats1.SetValue(Stats11)

          Scali11 = str(Scali)
          Scals11 = str(Scals)         
          self.scali1.SetValue(Scali11)
          self.scals1.SetValue(Scals11)

          print >> fileout, ' '
          print >> fileout, ' function 2 : statistics'

          fminp2 = min(fminp2m)
          fmaxp2 = max(fmaxp2m)
          favep2 = sum(fsum2m)/sumtot
          sum2 = sum(fsum2m)
          mfun22 = sum(fsum22m)       

          dsqp = mfun22-2*favep2*sum2+sumtot*favep2*favep2
          fsigp = dsqp/sumtot
          fsigmap2 = np.sqrt(fsigp)

          print >> fileout, ' initial scale: min,max,ave,sq,sig' + "%9.4f" %fminp2 + "%9.4f" %fmaxp2 + "%9.4f" %favep2 + "%9.4f" %fsigp + "%9.4f" %fsigmap2
          Stati = "%12.4f" %fminp2 + "%12.4f" %fmaxp2 + "%12.4f" %favep2 + "%12.4f" %fsigmap2

# file2 - after normalization

          fmin2 = fmin2ms = (fminp2-favep2)/fsigmap2
          fmax2 = fmax2ms = (fmaxp2-favep2)/fsigmap2
          fave2 = 0.

          fs2 = fsigmap2*fsigmap2
          dsq = dsqp-2*fave2*fsigmap2*(sum2-sumtot*favep2)+sumtot*fave2*fave2*fs2
          dsq= dsq/fs2
          fsig = dsq/sumtot
          fsigma2 = np.sqrt(fsig)

          print >> fileout, ' sigma scale  : min,max,ave,sq,sig' + "%9.4f" %fmin2 + "%9.4f" %fmax2 + "%9.4f" %fave2 + "%9.4f" %fsig + "%9.4f" %fsigma2
          Stats = "%12.4f" %fmin2 + "%12.4f" %fmax2 + "%12.4f" %fave2 + "%12.4f" %fsigma2

          rho = 0.
          f = rho*fsigmap2+favep2
          if f < meps: Scali = "%12.4f" %f
          else: Scali = "%12.2e" %f
          if rho < meps: Scals = "%12.4f" %rho
          else: Scals = "%12.2e" %rho

          Stati21 = str(Stati)
          Stats21 = str(Stats)
          self.stati2.SetValue(Stati21)
          self.stats2.SetValue(Stats21)

          Scali21 = str(Scali)
          Scals21 = str(Scals)
          self.scali2.SetValue(Scali21)
          self.scals2.SetValue(Scals21)

        khis1m = zeros(mhis) 
        chis1m = zeros(mhis)
        skhis1m = zeros(shis)
        schis1m = zeros(shis)

        khis2m = zeros(mhis) 
        chis2m = zeros(mhis)
        skhis2m = zeros(shis)
        schis2m = zeros(shis)

        if nstr != 1:

# 2nd read of sections

         filemap1.seek(0)
         filemap2.seek(0)
         filemap3.seek(0)

         if ftype == 1:
          lin = filemap1.read(fmsz1)
          lin = filemap2.read(fmsz2)
          lin = filemap3.read(fmsz3)
         else: 
          for i in xrange(nlin):
           lin = filemap1.readline()
           lin = filemap2.readline()
           lin = filemap3.readline()

        dhis1 = float(fmax1-fmin1)/float(mhis)
        dhis2 = float(fmax2-fmin2)/float(mhis)

        for isec in xrange(nstr):  

         if nstr != 1:
 
          if ftype == 1: 
            self.Readm_ccp4(filemap1,ntot)
            vmap1 = vmap
            self.Readm_ccp4(filemap2,ntot)
            vmap2 = vmap
            self.Readm_ccp4(filemap3,ntot)
            vmap3 = vmap
          else: 
            self.Readm_xpl(filemap1,ma,mb,mc)
            vmap1 = vmap
            self.Readm_xpl(filemap2,ma,mb,mc)
            vmap2 = vmap          
            self.Readm_xpl(filemap3,ma,mb,mc)
            vmap3 = vmap

          self.Selmsk()

         if len(vmap1) != 0:

           fsum12.append(sum(vmap1*vmap2))

# functions rescaling in sigmas

           vmap1 = (vmap1-favep1)/fsigmap1
           vmap2 = (vmap2-favep2)/fsigmap2

           fsum1s.append(sum(vmap1))
           fsum2s.append(sum(vmap2))
           fsum11s.append(sum(vmap1*vmap1))
           fsum22s.append(sum(vmap2*vmap2))
           fsum12s.append(sum(vmap1*vmap2))

# calcul of histograms 
      
           di = vmap1-fmin1

           jhis1 = (di/dhis1).astype(int)
           jhis1 = np.where(jhis1 <= mhis-1, jhis1, mhis-1)

           di = vmap2-fmin2

           jhis2 = (di/dhis2).astype(int) 
           jhis2 = np.where(jhis2 <= mhis-1, jhis2, mhis-1)
 
           for i in xrange(len(vmap1)):
            khis1m[jhis1[i]] = khis1m[jhis1[i]]+1 
            khis2m[jhis2[i]] = khis2m[jhis2[i]]+1 

        ahis1 = khis1m/sumtot
        ahis2 = khis2m/sumtot

        chis1m[0] = ahis1[0]
        chis2m[0] = ahis2[0]

        for i in xrange(1,mhis):
         chis1m[i] = chis1m[i-1]+ahis1[i]
         chis2m[i] = chis2m[i-1]+ahis2[i]

        chis1m = np.where(chis1m <= 1.0, chis1m, 1.0)
        chis2m = np.where(chis2m <= 1.0, chis2m, 1.0)

        ms = int(mhis)/int(shis)
        if mhis-ms*shis > 0: ms = ms+1

        for j in xrange(1,shis):
         for i in xrange(mhis):
          if i >= ms*(j-1) and i < ms*j: 
              skhis1m[j] = skhis1m[j]+khis1m[i]
              schis1m[j] = schis1m[j]+chis1m[i]
              skhis2m[j] = skhis2m[j]+khis2m[i]
              schis2m[j] = schis2m[j]+chis2m[i]

        k = int((rho-fmin1)/dhis1)
        rhok = fmin1+k*dhis1  
        q = chis1m[k]+(chis1m[k+1]-chis1m[k])*(rho-rhok)/dhis1 
        Squan = "%12.4f" %q
        Squan11 = str(Squan)
        self.squan1.SetValue(Squan11)

        k = int((rho-fmin2)/dhis2)
        rhok = fmin2+k*dhis2  
        q = chis2m[k]+(chis2m[k+1]-chis2m[k])*(rho-rhok)/dhis2 
        Squan = "%12.4f" %q
        Squan21 = str(Squan)
        self.squan2.SetValue(Squan21)

        khis1m = skhis1m
        chist1m = chis1m  
        chis1m = schis1m

        khis2m = skhis2m
        chist2m = chis2m
        chis2m = schis2m

        mfun12 = sum(fsum12)

        sum1s = sum(fsum1s)
        sum2s = sum(fsum2s)
        mfun11s = sum(fsum11s)
        mfun22s = sum(fsum22s)
        mfun12s = sum(fsum12s)

# correlation : initial scale 

        error_mes = tmes.GetValue()  
        if not error_mes:
          self.Scorr(sum1,sum2,mfun11,mfun22,mfun12,sumtot)  
          corrn = crn
          corrc = crc

# correlation : sigma scale

        error_mes = tmes.GetValue()  
        if not error_mes: 
          self.Scorr(sum1s,sum2s,mfun11s,mfun22s,mfun12s,sumtot)
          corrsn = crn
          corrsc = crc 

# histogram 1 and 2 file
        error_mes = tmes.GetValue()  
        if not error_mes:  
            hiswin = Hist_Graph(self)

       error_mes = tmes.GetValue()  
       if not error_mes and flagfile1 != 0 and flagfile2 != 0: 
         btnRun1.Enable()
         btnRun2.Enable()

#-------------------------------------
# Xplor format

    def Read_xplor(self, evt):
       global na, amin, amax, nb, bmin, bmax, nc, cmin, cmax
       global ma, mb, mc
       global nlin, vmap
       global flagfile1, flagfile2, flagfile3, Grid, Grid3
       global filemap,ifile1, ifile2, ifile3, Filename, Filename11, Filename22, ftype
       global line11, line12, line21, line22, linetit1, linetit2, line31, line32, line41, line42, line51, line52  

       nlin = 0
       linetit = []

       cell = zeros(6)

       if ifile1 != -1: 
         Filename = Filename1
         Filename11 = Filename1
       if ifile2 != -1: 
         Filename = Filename2
         Filename22 = Filename2
       if ifile3 != -1: Filename = Filename3

       try:
           filemap = open(Filename, 'r')
       except IOError:
           tmes.SetValue(" No such file or directory : " + Filename)
           return  

       line1 = filemap.readline()
       if len(line1.split())  != 0: 
        if ifile1 != -1: flagfile1 = 0 
        if ifile2 != -1: flagfile2 = 0 
        if ifile3 != -1: flagfile3 = 0 
        return
       
       if ifile1 != -1 and flagfile1 == 1: return 
       if ifile2 != -1 and flagfile2 == 1: return 
       if ifile3 != -1 and flagfile3 == 1: return 

       line2 = filemap.readline()

       ntitle = int(line2.split()[0]) 
       nlin = nlin+2

       if ntitle != 0:
        for i in xrange(ntitle): 
          linetit.append(filemap.readline())
          nlin = nlin+1

# read section information

       line3 = filemap.readline()

       na = int(line3.split()[0])
       amin = int(line3.split()[1])
       amax = int(line3.split()[2])
       nb = int(line3.split()[3])
       bmin = int(line3.split()[4])
       bmax = int(line3.split()[5])
       nc = int(line3.split()[6])
       cmin = int(line3.split()[7])
       cmax = int(line3.split()[8])   

       nlin = nlin+1

       Grid = str(na)+'  '+str(amin)+'  '+str(amax)+'  '+str(nb)+'  '+str(bmin)+'  '+str(bmax)+'  '+str(nc)+'  '+str(cmin)+'  '+str(cmax)
       if flagfile1 != 0 and flagfile2 != 0: 
          Grid3 = str(Grid)
          self.grid3.SetValue(Grid3)
          if Grid3 != "" and Grid3 != Grid1:
             tmes.SetValue("Grids for the functions and the mask are different: " + Grid1 + " and "+ Grid3)
             return 

# read unit cell constants in angstroms and degrees 

       line4 = filemap.readline()
       cell[0] = float(line4.split()[0])
       cell[1] = float(line4.split()[1])
       cell[2] = float(line4.split()[2])
       cell[3] = float(line4.split()[3])
       cell[4] = float(line4.split()[4])
       cell[5] = float(line4.split()[5])
  
       nlin = nlin+1

# read matrix mode

       line5 = filemap.readline()
       ax = str(line5.split()[0])
       nlin = nlin+1
       
       if str(ax) == 'XYZ':
          ma = cmax-cmin+1
          mb = bmax-bmin+1
          mc = amax-amin+1
       elif str(ax) == 'XZY':
          ma = bmax-bmin+1
          mb = cmax-cmin+1
          mc = amax-amin+1          
       elif str(ax) == 'YXZ':
          ma = cmax-cmin+1
          mb = amax-amin+1
          mc = bmax-bmin+1 
       elif str(ax) == 'YZX':
          ma = amax-amin+1
          mb = cmax-cmin+1
          mc = bmax-bmin+1
       elif str(ax) == 'ZXY':
          ma = bmax-bmin+1
          mb = amax-amin+1
          mc = cmax-cmin+1
       elif str(ax) == 'ZYX':
          ma = amax-amin+1
          mb = bmax-bmin+1
          mc = cmax-cmin+1               
       else: 
          tmes.SetValue("Wrong file:" + Filename)
          return 

       cell[0] = cell[0]*float(ma)/float(na)
       cell[1] = cell[1]*float(mb)/float(nb)
       cell[2] = cell[2]*float(mc)/float(nc)

       if ifile1 != -1: 
          flagfile1 = 1
          line11 = line1
          line21 = line2
          linetit1 = linetit
          line31 = line3
          line41 = line4
          line51 = line5
       if ifile2 != -1: 
          flagfile2 = 1
          line12 = line1
          line22 = line2
          linetit2 = linetit
          line32 = line3
          line42 = line4
          line52 = line5
       if ifile3 != -1: flagfile3 = 1 

       ftype = 0

       return 

#-------------------------------------
# Xplor - read density matrix  

    def Readm_xpl(self,filemap,ma,mb,mc):
       global vmap, imap

       nsec = ma*mb
       nsmc = nsec*mc
       if nsmc <= lmem: ntot = nsmc
       else: ntot = nsec

       vmap = zeros(ntot)

       imap = 0

       while imap < ntot:

         line = filemap.readline()
         try:  

          if len(line) <= 10: 
               numsec = line.split()
               if float(numsec[0]) < 0.0: return
	       
          if len(line) >10 and len(line) <= 14: 
               vmap[imap]   = float(line[0:12])
               imap = imap+1
	       
          if len(line) > 14 and len(line) <= 26: 
               vmap[imap]   = float(line[0:12])
               vmap[imap+1] = float(line[12:24])
               imap = imap+2
	       
          if len(line) > 26 and len(line) <= 38:
               vmap[imap]   = float(line[0:12])
               vmap[imap+1] = float(line[12:24]) 
               vmap[imap+2] = float(line[24:36])
               imap = imap+3
	       
          if len(line) > 38 and len(line) <= 50: 
               vmap[imap]   = float(line[0:12])
               vmap[imap+1] = float(line[12:24]) 
               vmap[imap+2] = float(line[24:36])
               vmap[imap+3] = float(line[36:48])
               imap = imap+4
	       
          if len(line) > 50 and len(line) <= 62:
               vmap[imap]   = float(line[0:12])
               vmap[imap+1] = float(line[12:24]) 
               vmap[imap+2] = float(line[24:36])
               vmap[imap+3] = float(line[36:48])
               vmap[imap+4] = float(line[48:60])
               imap = imap+5
                  
          if len(line) > 62: 
               vmap[imap]   = float(line[0:12])
               vmap[imap+1] = float(line[12:24])
               vmap[imap+2] = float(line[24:36])
               vmap[imap+3] = float(line[36:48])
               vmap[imap+4] = float(line[48:60])
               vmap[imap+5] = float(line[60:72])
               imap = imap+6

         except ValueError:
           tmes.SetValue(" Failed to read the file : " + Filename)
           return  

       return
            
#-------------------------------------
# Ccp4 format

    def Read_ccp4(self, evt):
       global mx, minx, maxx, my, miny, maxy, mz, minz, maxz
       global ftype, flagfile1, flagfile2, flagfile3, Grid, Grid3
       global ifile1, ifile2, ifile3
       global ma, mb, mc, vmap, filemap, Filename, Filename11, Filename22
       global fmr, fmsz, nsymbt
       global cod1, cod2, lins1, lins2, numsym

       if ifile1 != -1: 
         Filename = Filename1
         Filename11 = Filename1
       if ifile2 != -1: 
         Filename = Filename2  
         Filename22 = Filename2
       if ifile3 != -1: Filename = Filename3

       try:
           filemap = open(Filename, 'rb')
       except IOError:
           tmes.SetValue(" No such file or directory : " + Filename)
           return

       kstamp = [16708, 4369, 1145110528, 286326784]
       cell = zeros(6)
       titccp = []
       lins1 = []
       lins2 = []

       fm = '@10i6f3i3f3i12f15f4sifi80s80s80s80s80s80s80s80s80s80s'
       fmr = '@f'
       fmsz = struct.calcsize(fm)
       lin = filemap.read(fmsz)
       cod = struct.unpack(fm, lin)

       machst = cod[53]

       if machst == kstamp[1]:
         filemap.seek(0)
         fm = '>10i6f3i3f3i12f15f4sifi80s80s80s80s80s80s80s80s80s80s'
         fmr = '>f' 
         fmsz = struct.calcsize(fm)
         lin = filemap.read(fmsz)
         cod = struct.unpack(fm, lin)
       if machst == kstamp[2]: 
         filemap.seek(0)
         fm = '<10i6f3i3f3i12f15f4sifi80s80s80s80s80s80s80s80s80s80s'
         fmr = '<f' 
         fmsz = struct.calcsize(fm)
         lin = filemap.read(fmsz)
         cod = struct.unpack(fm, lin)
  
       if machst != kstamp[0] and machst == kstamp[1] and machst != kstamp[2] and machst == kstamp[3]: 
          tmes.SetValue(" Sorry : unknown machine stamp" + machst + "please check the hexagonal presentation")
          return

       nc, nr, ns = cod[0], cod[1], cod[2]
       mode = cod[3]
       ncstart, nrstart, nsstart = cod[4], cod[5], cod[6]
       nx, ny, nz = cod[7], cod[8], cod[9]
       for i in xrange(6): cell[i] = cod[10+i]
       mapc, mapr, maps = cod[16], cod[17], cod[18]
       dmin, dmax, dmean = cod[19], cod[20], cod[21]
       ispg = cod[22]
       nsymbt = cod[23]
       lskflg = cod[24]
       s11, s12, s13 = cod[25], cod[26], cod[27]
       s21, s22, s23 = cod[28], cod[29], cod[30]
       s31, s32, s33 = cod[31], cod[32], cod[33]
       st1, st2, st3 = cod[34], cod[35], cod[36]
       map2 = cod[52]
       
       if map2 != 'MAP ': 
         if ifile1 != -1: flagfile1 = 0
         if ifile2 != -1: flagfile2 = 0
         if ifile3 != -1: flagfile3 = 0
         ftype = 0
         filemap.close()
         return

       drms = cod[54]
       nlabl = cod[55]
       if nlabl > 0:
          for j in xrange(nlabl):
            titccp.append(cod[56+j])

# skip symmetries

       fmsbt= "80s"
       fsbt = struct.calcsize(fmsbt)
       numsym = int(nsymbt/80.)
       for i in xrange(numsym):
        try: 
         if ifile1 != -1: lins1.append(filemap.read(fsbt))
         if ifile2 != -1: lins2.append(filemap.read(fsbt))
        except ValueError:
           tmes.SetValue(" Wrong file : " + Filename)
           return
        
       print >> fileout, 'MODE parameter - type of the array', mode
       print >> fileout, 'number of columns, raws, sections           ', nc, nr, ns
       print >> fileout, 'starting numbers for columns, raws, sections', ncstart, nrstart, nsstart
       print >> fileout, 'code of variable for columns, raws, sections', mapc, mapr, maps
       print >> fileout, '(1=x, 2=y, 3=z)'
       print >> fileout, 'grid numbers on X, Y, Z :', nx, ny, nz
       print >> fileout, 'space group number', ispg
       print >> fileout, 'number of bytes for the symmetry operations', nsymbt
       print >> fileout, 'number of titles used', nlabl
       print >> fileout, 'flag for skewing', lskflg
       print >> fileout, ' and skew matrix & vector'
       print >> fileout, '%9.6f' %s11, '%9.6f' %s12, '%9.6f' %s13
       print >> fileout, '%9.6f' %s21, '%9.6f' %s22, '%9.6f' %s23
       print >> fileout, '%9.6f' %s31, '%9.6f' %s32, '%9.6f' %s33 
       print >> fileout, ''
       print >> fileout, '%9.6f' %st1, '%9.6f' %st2, '%9.6f' %st3
       print >> fileout, 'precalculated statistics : min,max,mean,rms:'
       print >> fileout, '%15.7g' %dmin, '%15.7g' %dmax, '%15.7g' %dmean, '%15.7g' %drms
       print >> fileout, nlabl, ' used titles from 10 allowed follow :'
       if nlabl > 0:
          for j in xrange(nlabl):
            print >> fileout, j+1, titccp[j]

       if mapc == 1:
          ma = nc
          amin = ncstart
       elif mapc == 2:
          mb = nc
          bmin = ncstart
       elif mapc == 3:
          mc = nc
          cmin = ncstart
       else: 
          tmes.SetValue("Wrong file:" + Filename)
          return 

       if mapr == 1:
          ma = nr
          amin = nrstart
       elif mapr == 2:
          mb = nr
          bmin = nrstart
       elif mapr == 3:
          mc = nr
          cmin = nrstart
       else:
          tmes.SetValue("Wrong file:" + Filename)
          return 

       if maps == 1: 
          ma = ns
          amin = nsstart
       elif maps == 2:
          mb = ns
          bmin = nsstart
       elif maps == 3:
          mc = ns
          cmin = nsstart
       else:
          tmes.SetValue("Wrong file:" + Filename)
          return 

       amax = amin+ma-1
       bmax = bmin+mb-1
       cmax = cmin+mc-1

       na = nx
       nb = ny
       nc = nz

       Grid = str(nx)+'  '+str(amin)+'  '+str(amax)+'  '+str(ny)+'  '+str(bmin)+'  '+str(bmax)+'  '+str(nz)+'  '+str(cmin)+'  '+str(cmax)

       if flagfile1 != 0 and flagfile2 != 0: 
         Grid3 = str(Grid)
         self.grid3.SetValue(Grid3)
         if Grid3 != "" and Grid3 != Grid1:
           tmes.SetValue("Grids for the functions and the mask are different: " + Grid1 + " and "+ Grid3)
           return 

       fc = "%10.3f"
       cl1 = fc %float(cell[0])
       cl2 = fc %float(cell[1])
       cl3 = fc %float(cell[2])
       cl4 = fc %float(cell[3])
       cl5 = fc %float(cell[4])
       cl6 = fc %float(cell[5])
  
       print >> fileout, 'input cell parameters' + cl1 + cl2 + cl3 + cl4 + cl5 + cl6

       cell[0] = cell[0]*float(ma)/float(na)
       cell[1] = cell[1]*float(mb)/float(nb)
       cell[2] = cell[2]*float(mc)/float(nc)

       if ifile1 != -1: 
         flagfile1 = 1
         cod1 = cod
       if ifile2 != -1: 
         flagfile2 = 1
         cod2 = cod
       if ifile3 != -1: flagfile3 = 1 

       ftype = 1

       return 

#-------------------------------------
# Ccp4 - read density matrix  

    def Readm_ccp4(self,filemap,ntot):
       global vmap, fnew, fmrsz
    
       vmap = zeros(ntot)

       fnew = fmr[0]+str(ntot)+'f'
       fmrsz = struct.calcsize(fnew)

       lin1 = filemap.read(fmrsz)       
       vmap[0:ntot] = struct.unpack(fnew, lin1)

       return

#-------------------------------------
# Scaling in standard deviations (sigma)

    def ScaSig(self,ltot):
        global fmin, fmax, fave, fsig, fsigma, Stati, Stats, Scali, Scals
        global fminp, fmaxp, favep, fsigmap
        global sump, mfunp

        fminp = min(fminp)
        fmaxp = max(fmaxp)
        favep = mean(favep)
        sump = sum(fsum)
        mfunp = sum(fsum2)   

        dsqp = mfunp-2*favep*sump+nsmc*favep*favep
        fsigp = dsqp/nsmc
        fsigmap = np.sqrt(fsigp)

        print >> fileout, ' initial scale: min,max,ave,sq,sig' + "%9.4f" %fminp + "%9.4f" %fmaxp + "%9.4f" %favep + "%9.4f" %fsigp + "%9.4f" %fsigmap
        Stati = "%12.4f" %fminp + "%12.4f" %fmaxp + "%12.4f" %favep + "%12.4f" %fsigmap

# after normalization

        fmin = (fminp-favep)/fsigmap
        fmax = (fmaxp-favep)/fsigmap
        fave = 0.
        fs2 = fsigmap*fsigmap
        dsq = dsqp-2*fave*fsigmap*(sump-nsmc*favep)+nsmc*fave*fave*fs2
        dsq= dsq/fs2
        fsig = dsq/nsmc
        fsigma = np.sqrt(fsig)

        print >> fileout, ' sigma scale  : min,max,ave,sq,sig' + "%9.4f" %fmin + "%9.4f" %fmax + "%9.4f" %fave + "%9.4f" %fsig + "%9.4f" %fsigma
        Stats = "%12.4f" %fmin + "%12.4f" %fmax + "%12.4f" %fave + "%12.4f" %fsigma

        rho = 0.
        f = rho*fsigmap+favep
        if f < meps: Scali = "%12.4f" %f
        else: Scali = "%12.2e" %f
        if rho < meps: Scals = "%12.4f" %rho
        else: Scals = "%12.2e" %rho

        return    

#-------------------------------------
# Select grid nodes inside the mask

    def Selmsk(self):
      global mtot, vmap1, vmap2
      
#     compress the syntheses : only points that belong to the mask

      mtot = 0
      
      ind = np.where(vmap3 > 0.0)
      ind =  ind[0]
     
      vmap1 = np.take(vmap1, ind)
      vmap2 = np.take(vmap2, ind)
      mtot = len(vmap1)

      return

#-------------------------------------
# Correlation

    def Scorr(self,sum1,sum2,mfun11,mfun22,mfun12,ns):
      global crn, crc
   
      fun1a = sum1/ns
      fun2a = sum2/ns

      sum12c = mfun12-sum1*fun2a-sum2*fun1a+ns*fun1a*fun2a
      sum11c = mfun11-2*sum1*fun1a+ns*fun1a*fun1a
      sum22c = mfun22-2*sum2*fun2a+ns*fun2a*fun2a
    
      crn = mfun12/np.sqrt(mfun11*mfun22)
      crc = sum12c/np.sqrt(sum11c*sum22c)
     
      return

#-------------------------------------
# Rank

    def Quantr(self,evt):
     global fquantr, vmap1, vmap2, vmap3
     global diswin, diswinm, corrpn, corrpn1, corrpc, corrpc1, qpeak, tcor
     global ndfun, anu, n12d, discf, discfm
     global sumc1, sumc2, ccn, ccc
     global qrank, sumnodq, sumc1q, sumc2q, ccnq, cccq
     global fsum1rcnq, fsum2rcnq, fsum11rcnq, fsum22rcnq, fsum12rcnq
     global fsum1rccq, fsum2rccq, fsum11rccq, fsum22rccq, fsum12rccq

     id = evt.GetId()

     if id == 600:
       btnRun1.SetBackgroundColour(col1)
       btnRun1.ClearBackground()
       btnRun1.SetLabel('peak correlations')
     if id == 700:
       btnRun2.SetBackgroundColour(col1)
       btnRun2.ClearBackground()
       btnRun2.SetLabel('discrepancy function')   

     qrank = self.rank.GetValue()
     try:
         qrank = float(qrank)
     except ValueError:
         tmes.SetValue(" Wrong symbol in the parameter")
         return 
     if qrank < 0.5 or qrank >= 1.0: 
         tmes.SetValue(" Wrong rank parameter: 0.5 <= qrank < 1")
         return 

     ndfun = self.div.GetValue()
     try:
         ndfun = int(ndfun)
     except ValueError:
         tmes.SetValue(" Wrong symbol in the parameter")
         return 
     if ndfun < 5 or ndfun > 200: 
         tmes.SetValue(" Wrong number of intervals: 5 <= ndfun <= 200")
         return 

     if fquantr == 0:
 
      tcor = []   
      sumc1, sumc2  = zeros(7), zeros(7)
      sumnodq, sumc1q, sumc2q = 0, 0, 0
  
      fsum1rcnq, fsum2rcnq, fsum11rcnq, fsum22rcnq, fsum12rcnq = 0, 0, 0, 0, 0
      fsum1rccq, fsum2rccq, fsum11rccq, fsum22rccq, fsum12rccq = [], [], [], [], []
         
      ccn, ccc = zeros(7), zeros(7)
      ccnq, cccq = 0, 0

      tmes.SetValue("")
   
      if isave == 0: self.RankRes()

# correlation : rank scale

      if flagfile3 == 0: 
        discf = np.divide(sumn,arand)
        nnn = nsmc
      else: 
        discfm = np.divide(sumnd12,arand)
        nnn = sumtot

      sum1r = sum(fsum1r)
      sum2r = sum(fsum2r)
      mfun11r = sum(fsum11r)
      mfun22r = sum(fsum22r)
      mfun12r = sum(fsum12r)

      error_mes = tmes.GetValue()  
      if not error_mes:        
            self.Scorr(sum1r,sum2r,mfun11r,mfun22r,mfun12r,nnn)
            if flagfile3 == 0:
             corrpn = corrpn1 = crn
             corrpc = corrpc1 = crc
            else:
             corrpn = crn
             corrpc = crc

      print >> fileout, ' '
      print >> fileout, 'correlation coefficients : non-centered and centered '
      if flagfile3 == 0:
       print >> fileout, '      CC , initial scale' + "%10.3f" %corrn1 + "       " + "%10.3f" %corrc1 
       print >> fileout, '      CC , sigma   scale' + "%10.3f" %corrsn1 + "       " + "%10.3f" %corrsc1
       print >> fileout, '      CCP, rank    scale' + "%10.3f" %corrpn1 + "       " + "%10.3f" %corrpc1
      else:     
       print >> fileout, '      CC , initial scale' + "%10.3f" %corrn + "       " + "%10.3f" %corrc 
       print >> fileout, '      CC , sigma   scale' + "%10.3f" %corrsn + "       " + "%10.3f" %corrsc
       print >> fileout, '      CCP, rank    scale' + "%10.3f" %corrpn + "       " + "%10.3f" %corrpc

      print >> fileout, 'CCpeak will be calculated for the rank values: ', ppeaks

      print >> fileout, ' '
      print >> fileout, ltitle + " (n/c,cen)"

      for i in xrange(nppeak):
        pcut = ppeaks[i]    
        sumc1[i] = fsum1rcn[i]/sumnod[i]
        sumc2[i] = fsum2rcn[i]/sumnod[i]
        ccn[i] = fsum12rcn[i]/np.sqrt(fsum11rcn[i]*fsum22rcn[i])

        if i == 0:
             m1s = sum(fsum1rcc1)
             m2s = sum(fsum2rcc1)
             m11s = sum(fsum11rcc1)
             m22s = sum(fsum22rcc1)
             m12s = sum(fsum12rcc1)
        elif i == 1:
             m1s = sum(fsum1rcc2)
             m2s = sum(fsum2rcc2)
             m11s = sum(fsum11rcc2)
             m22s = sum(fsum22rcc2)
             m12s = sum(fsum12rcc2)
        elif i == 2:
             m1s = sum(fsum1rcc3)
             m2s = sum(fsum2rcc3)
             m11s = sum(fsum11rcc3)
             m22s = sum(fsum22rcc3)
             m12s = sum(fsum12rcc3)
        elif i == 3:
             m1s = sum(fsum1rcc4)
             m2s = sum(fsum2rcc4)
             m11s = sum(fsum11rcc4)
             m22s = sum(fsum22rcc4)
             m12s = sum(fsum12rcc4)
        elif i == 4:
             m1s = sum(fsum1rcc5)
             m2s = sum(fsum2rcc5)
             m11s = sum(fsum11rcc5)
             m22s = sum(fsum22rcc5)
             m12s = sum(fsum12rcc5)
        elif i == 5:
             m1s = sum(fsum1rcc6)
             m2s = sum(fsum2rcc6)
             m11s = sum(fsum11rcc6)
             m22s = sum(fsum22rcc6)
             m12s = sum(fsum12rcc6)
        elif i == 6:
             m1s = sum(fsum1rcc7)
             m2s = sum(fsum2rcc7)
             m11s = sum(fsum11rcc7)
             m22s = sum(fsum22rcc7)
             m12s = sum(fsum12rcc7)

        s11 = m11s-2*sumc1[i]*m1s+sumnod[i]*sumc1[i]*sumc1[i]
        s22 = m22s-2*sumc2[i]*m2s+sumnod[i]*sumc2[i]*sumc2[i]
        s12 = m12s-sumc1[i]*m2s-sumc2[i]*m1s+sumnod[i]*sumc1[i]*sumc2[i]
        ccc[i] = s12/np.sqrt(s11*s22)

        if flagfile3 == 0: self.P2sig(pcut,fmin11,fmax11,fave11,fsigma11,chist1) 
        if flagfile3 != 0: self.P2sig(pcut,fmin1,fmax1,fave1,fsigma1,chist1m) 
        sp1 = s0
        dp1 = den0
        if flagfile3 == 0: self.P2sig(pcut,fmin21,fmax21,fave21,fsigma21,chist2)
        if flagfile3 != 0: self.P2sig(pcut,fmin2,fmax2,fave2,fsigma2,chist2m)
        sp2 = s0
        dp2 = den0

        if pcut == qrank: qpeak = ccc[i]

        ii = i+1  
        tcor.append("%2i" %ii + "%11.3f" %pcut + "%16.5g" %dp1 + "%13.5g" %dp2 + ' ' + "%8.4f" %sp1 + "%8.4f" %sp2 + "%10i" %sumnod[i] + "%9.3f" %ccc[i])
        print >> fileout, "%2i" %ii + "%11.3f" %pcut + "%16.5g" %dp1 + "%13.5g" %dp2 + ' ' + "%8.4f" %sp1 + "%8.4f" %sp2 + "%10i" %sumnod[i] + "%10.3f" %ccn[i] + "%8.3f" %ccc[i]

      if qrank not in ppeaks: 
     
        sumc1q = fsum1rcnq/sumnodq
        sumc2q = fsum2rcnq/sumnodq

        ccnq = fsum12rcnq/np.sqrt(fsum11rcnq*fsum22rcnq)

        m1s = sum(fsum1rccq)
        m2s = sum(fsum2rccq)
        m11s = sum(fsum11rccq)
        m22s = sum(fsum22rccq)
        m12s = sum(fsum12rccq)

        s11 = m11s-2*sumc1q*m1s+sumnodq*sumc1q*sumc1q
        s22 = m22s-2*sumc2q*m2s+sumnodq*sumc2q*sumc2q
        s12 = m12s-sumc1q*m2s-sumc2q*m1s+sumnodq*sumc1q*sumc2q
        cccq = s12/np.sqrt(s11*s22)

        if flagfile3 == 0: self.P2sig(qrank,fmin1,fmax1,fave1,fsigma1,chist1) 
        if flagfile3 != 0: self.P2sig(qrank,fmin1,fmax1,fave1,fsigma1,chist1m) 
        sp1 = s0
        dp1 = den0
        if flagfile3 == 0: self.P2sig(qrank,fmin2,fmax2,fave2,fsigma2,chist2)
        if flagfile3 != 0: self.P2sig(qrank,fmin2,fmax2,fave2,fsigma2,chist2m)
        sp2 = s0
        dp2 = den0

        qpeak = cccq

        tcor.append(" 8" + "%11.3f" %qrank + "%16.5g" %dp1 + "%13.5g" %dp2 + ' ' + "%8.4f" %sp1 + "%8.4f" %sp2 + "%10i" %sumnodq + "%9.3f" %cccq)
        print >> fileout, " 8" + "%11.3f" %qrank + "%16.5g" %dp1 + "%13.5g" %dp2 + ' ' + "%8.4f" %sp1 + "%8.4f" %sp2 + "%10i" %sumnodq + "%10.3f" %ccnq + "%8.3f" %cccq

     Param_Dis(self)

     if id == 600: 
       if flagfile3 == 0: 
         if not diswin: diswin = Dis_Panel(self)  
         Dis_Inf(self)
       if flagfile3 != 0: 
         if not diswinm: diswinm = Dis_Panelm(self) 
         Dis_Inf(self) 
       btnRun1.SetBackgroundColour(col5)

     if id == 700:
       if flagfile3 == 0: 
         if not diswin: diswin = Dis_Panel(self) 
       if flagfile3 != 0: 
         if not diswinm: diswinm = Dis_Panelm(self)   
       self.Dcurve(self)
       btnRun2.SetBackgroundColour(col5)

     fquantr = 1

     return

#-------------------------------------
# Rescaling in rankl scale

    def RankRes(self):
      global vmap1, vmap2, vmap3, filexpl1, filexpl2, fileccp1, fileccp2, Filesave1, Filesave2
      global fsum1r, fsum2r, fsum11r, fsum22r, fsum12r, arand, atot2, anu, cod1, cod2
      global nppeak, ppeaks, sumnod, sumn, sumnd12
      global fsum1rcn, fsum2rcn, fsum11rcn, fsum22rcn, fsum12rcn
      global fsum1rcc1, fsum1rcc2, fsum1rcc3, fsum1rcc4, fsum1rcc5, fsum1rcc6, fsum1rcc7
      global fsum2rcc1, fsum2rcc2, fsum2rcc3, fsum2rcc4, fsum2rcc5, fsum2rcc6, fsum2rcc7
      global fsum11rcc1, fsum11rcc2, fsum11rcc3, fsum11rcc4, fsum11rcc5, fsum11rcc6, fsum11rcc7
      global fsum22rcc1, fsum22rcc2, fsum22rcc3, fsum22rcc4, fsum22rcc5, fsum22rcc6, fsum22rcc7
      global fsum12rcc1, fsum12rcc2, fsum12rcc3, fsum12rcc4, fsum12rcc5, fsum12rcc6, fsum12rcc7

      nppeak = 7

      ppeaks = zeros(7)
      fsum1rcn, fsum2rcn, fsum11rcn, fsum22rcn, fsum12rcn = zeros(7), zeros(7), zeros(7), zeros(7), zeros(7)
      fsum1rcc1, fsum2rcc1, fsum11rcc1, fsum22rcc1, fsum12rcc1 = [], [], [], [], []
      fsum1rcc2, fsum2rcc2, fsum11rcc2, fsum22rcc2, fsum12rcc2 = [], [], [], [], []
      fsum1rcc3, fsum2rcc3, fsum11rcc3, fsum22rcc3, fsum12rcc3 = [], [], [], [], []
      fsum1rcc4, fsum2rcc4, fsum11rcc4, fsum22rcc4, fsum12rcc4 = [], [], [], [], []
      fsum1rcc5, fsum2rcc5, fsum11rcc5, fsum22rcc5, fsum12rcc5 = [], [], [], [], []
      fsum1rcc6, fsum2rcc6, fsum11rcc6, fsum22rcc6, fsum12rcc6 = [], [], [], [], []
      fsum1rcc7, fsum2rcc7, fsum11rcc7, fsum22rcc7, fsum12rcc7 = [], [], [], [], []

      ppeaks[0] = 0.5
      ppeaks[1] = 0.60
      ppeaks[2] = 0.70
      ppeaks[3] = 0.80
      ppeaks[4] = 0.90
      ppeaks[5] = 0.95
      ppeaks[6] = 0.99  

      sumnod = zeros(7)
      sumn, sumnd12 = zeros(ndfun-1), zeros(ndfun-1)

      fsum1r, fsum2r, fsum11r, fsum22r, fsum12r = [], [], [], [], []

      ddfun = 1./(ndfun)     
      j = arange(1,ndfun)
      anu = j*ddfun

      if isave == 1: 

        if flagfile1 != 0:
           s1 = Filename11.split('.')[0]
           s2 = Filename11.split('.')[1]
           Filesave1 = s1+'_rank.'+s2
           try:
            if ftype == 0:
              filexpl1 = open(Filesave1, 'w')
              filexpl1.write(line11) 
              filexpl1.write(line21) 
              for k in xrange(len(linetit1)):
                filexpl1.write(linetit1[k])                  
              filexpl1.write(line31) 
              filexpl1.write(line41) 
              filexpl1.write(line51) 
            if ftype == 1:
              fileccp1 = open(Filesave1, 'wb')
           except IOError:
            tmes.SetValue(" No such file or directory : " + Filesave1)
            return   

        if flagfile2 != 0: 
           s1 = Filename22.split('.')[0]
           s2 = Filename22.split('.')[1]
           Filesave2 = s1+'_rank.'+s2
           try:
            if ftype == 0:
              filexpl2 = open(Filesave2, 'w')
              filexpl2.write(line12) 
              filexpl2.write(line22) 
              for k in xrange(len(linetit2)):
                 filexpl2.write(linetit2[k])                  
              filexpl2.write(line32) 
              filexpl2.write(line42) 
              filexpl2.write(line52) 
            if ftype == 1:
              fileccp2 = open(Filesave2, 'wb')
           except IOError:
            tmes.SetValue(" No such file or directory : " + Filesave2)
            return   

      if flagfile3 == 0: 
        atot2 = nsmc*2.
        dhis1 = float(fmax11-fmin11)/float(mhis)
        dhis2 = float(fmax21-fmin21)/float(mhis)

      if flagfile3 != 0: 
        atot2 = sumtot*2.
        dhis1 = float(fmax1-fmin1)/float(mhis)
        dhis2 = float(fmax2-fmin2)/float(mhis)

      arand = anu*(1.-anu)*atot2

      if nstr != 1 or hiswin != "":

# 3rd read of sections

       filemap1.seek(0)
       filemap2.seek(0)
       if flagfile3 != 0: filemap3.seek(0)

       if ftype == 1:
         lin = filemap1.read(fmsz1)
         lin = filemap2.read(fmsz2)
         if flagfile3 != 0: lin = filemap3.read(fmsz3)
       else: 
         for i in xrange(nlin):
           lin = filemap1.readline()
           lin = filemap2.readline()
           if flagfile3 != 0: lin = filemap3.readline()

      if ftype == 0: 
       crmin = cmin
       imc = 0

      for isec in xrange(nstr):  

         if nstr != 1 or hiswin != "":
 
          if ftype == 1: 
            self.Readm_ccp4(filemap1,ntot)
            vmap1 = vmap
            self.Readm_ccp4(filemap2,ntot)
            vmap2 = vmap
            if flagfile3 != 0: 
              self.Readm_ccp4(filemap3,ntot)
              vmap3 = vmap
          else: 
            self.Readm_xpl(filemap1,ma,mb,mc)
            vmap1 = vmap
            self.Readm_xpl(filemap2,ma,mb,mc)
            vmap2 = vmap 
            if flagfile3 != 0: 
              self.Readm_xpl(filemap3,ma,mb,mc)
              vmap3 = vmap 

          if flagfile3 != 0: self.Selmsk() 

# functions rescaling in sigmas

         if len(vmap1) != 0:

           if flagfile3 == 0:
            sc1 = chist1[1:mhis]-chist1[0:mhis-1]
            sc2 = chist2[1:mhis]-chist2[0:mhis-1]

            if nstr != 1 or hiswin != "":  
             vmap1 = (vmap1-favep11)/fsigmap11
             vmap2 = (vmap2-favep21)/fsigmap21
            di1 = vmap1-fmin11
            di2 = vmap2-fmin21
           else:
            sc1 = chist1m[1:mhis]-chist1m[0:mhis-1]
            sc2 = chist2m[1:mhis]-chist2m[0:mhis-1]

            if nstr != 1 or hiswin != "":   
             vmap1 = (vmap1-favep1)/fsigmap1
             vmap2 = (vmap2-favep2)/fsigmap2
            di1 = vmap1-fmin1    
            di2 = vmap2-fmin2

           kk1 = (di1/dhis1).astype(int)
           tt1 = (di1-dhis1*kk1)/dhis1

           kk2 = (di2/dhis2).astype(int)
           tt2 = (di2-dhis2*kk2)/dhis2

# functions rescaling in rank scale

           for i in xrange(len(vmap1)):
 
            if flagfile3 == 0: 
             if kk1[i] >= mhis-2: vmap1[i] = 1.0
             else: vmap1[i] = chist1[kk1[i]]+sc1[kk1[i]]*tt1[i]
             if kk2[i] >= mhis-2: vmap2[i] = 1.0
             else: vmap2[i] = chist2[kk2[i]]+sc2[kk2[i]]*tt2[i]

            if flagfile3 != 0: 
             if kk1[i] >= mhis-2: vmap1[i] = 1.0
             else: vmap1[i] = chist1m[kk1[i]]+sc1[kk1[i]]*tt1[i]
             if kk2[i] >= mhis-2: vmap2[i] = 1.0
             else: vmap2[i] = chist2m[kk2[i]]+sc2[kk2[i]]*tt2[i]

            if isave == 1 and ftype == 0: 

             if nstr == 1:
  
              if i == nsec*imc:
               filexpl1.write('%8i \n' %crmin)
               filexpl2.write('%8i \n' %crmin)
               crmin = crmin+1
               imc = imc+1
               ii = 1
              if i == nsec*(imc-1)+6*ii : 
                filexpl1.write('\n')
                filexpl2.write('\n')
                ii = ii+1
              filexpl1.writelines('%12.5E' %vmap1[i])
              filexpl2.writelines('%12.5E' %vmap2[i])
              if i == nsec*imc-1: 
               filexpl1.write('\n')
               filexpl2.write('\n')

             if nstr != 1:

              if i == 0:
               filexpl1.write('%8i \n' %crmin)
               filexpl2.write('%8i \n' %crmin)
               crmin = crmin+1
               imc = imc+1
               ii = 1
              if i == 6*ii : 
                filexpl1.write('\n')
                filexpl2.write('\n')
                ii = ii+1
              filexpl1.writelines('%12.5E' %vmap1[i])
              filexpl2.writelines('%12.5E' %vmap2[i])
              if i == nsec-1: 
               filexpl1.write('\n')
               filexpl2.write('\n') 

           if isave == 1 and ftype == 1: 

              if isec == 0:

                cod1 = list(0.0 if i == 19 else v for i,v in enumerate(cod1))
                cod1 = list(1.0000 if i == 20 else v for i,v in enumerate(cod1))
                cod1 = list(0.5000 if i == 21 else v for i,v in enumerate(cod1))
                cod1 = list(0.2887 if i == 54 else v for i,v in enumerate(cod1))

                cod2 = cod1

                fm = '@10i6f3i3f3i12f15f4sifi80s80s80s80s80s80s80s80s80s80s'
                lin = struct.pack(fm, *cod1)
                fileccp1.write(lin)
                fileccp2.write(lin)

                fmsbt= "80s"
                for i in xrange(numsym):
                   lins = struct.pack(fmsbt, *lins1)
                   fileccp1.write(lins)
                   lins = struct.pack(fmsbt, *lins2)
                   fileccp2.write(lins)

              val1 = struct.pack('f'*len(vmap1), *vmap1)
              fileccp1.write(val1) 
              val2 = struct.pack('f'*len(vmap2), *vmap2)
              fileccp2.write(val2)  

           if isave == 1: tmes.SetValue(" Rank scale syntheses: " + Filesave1 + " and " + Filesave2) 
             
           fsum1r.append(sum(vmap1))
           fsum2r.append(sum(vmap2))
           fsum11r.append(sum(vmap1*vmap1))
           fsum22r.append(sum(vmap2*vmap2))
           fsum12r.append(sum(vmap1*vmap2)) 

# Cbased-cut-correlation: sums and nodes

           for i in xrange(nppeak):
              pcut = ppeaks[i]
              self.Ccvolc(i,isec,pcut) 

           if qrank not in ppeaks: self.Ccqrnk(isec,qrank) 

         if len(vmap1) != 0: self.Caldis(len(vmap1),ddfun) 

      if isave == 1 and ftype == 0:       
       filexpl1.close()
       filexpl2.close()
      if isave == 1 and ftype == 1:       
       fileccp1.close()
       fileccp2.close()

      return

#-------------------------------------
# Curve

    def Caldis(self,ltot,ddfun):
      global discf, discfm, sumn, sumnd12, n12d

      k1 = zeros(ltot)
      k2 = zeros(ltot)

      n12d = zeros(ndfun)

      if flagfile3 == 0: discf = zeros(ndfun) 
      if flagfile3 != 0: discfm = zeros(ndfun)    
      
      j1 = (vmap1/ddfun).astype(int)
      j2 = (vmap2/ddfun).astype(int)
    
      k1 = np.where(j1 < j2, j1+1, k1)
      k1 = np.where(j1 > j2, j2+1, k1)
      k2 = np.where(j1 < j2, j2, k2)
      k2 = np.where(j1 > j2, j1, k2)
      k1 = k1.astype(int)
      k2 = k2.astype(int)

      ind = np.where(j1 != j2)
      ind =  ind[0]

      for k in xrange(len(ind)):

       n1 = k1[ind[k]]
       n2 = k2[ind[k]]+1
       n12d[n1:n2] = n12d[n1:n2]+1

      n12d = n12d[1:]

      n12d = n12d.astype(float)

      if flagfile3 == 0: sumn = sumn+n12d
      if flagfile3 != 0: sumnd12 = sumnd12+n12d

      return

#-------------------------------------
# Discrepancy curve

    def Dcurve(self, evt):
      global ndfun, discf, discfm, diswin, diswinm, tcor, nppeak, ffn1, ffn2

      tmes.SetValue("")

      print >> fileout, ' '
      print >> fileout, 'Disrepancy curve:'
      print >> fileout, '    N        rank       N1+N2   D(quant)'

      if flagfile3 == 0: 
        for i in xrange(len(discf)):  
          ii = i+1      
          print >> fileout, "%5i" %ii, "%12.4f" %anu[i],"%10i" %sumn[i], "%10.6f" %discf[i]

          dpanel.Bind(wx.EVT_PAINT, self.DcDiv)
          dpanel.Refresh()

          menuBar2 = wx.MenuBar()
# export
          exportMenu2 = wx.Menu()
          exportMenu2.Append(200, "graphics to png")
          menuBar2.Append(exportMenu2, "Export")
          diswin.SetMenuBar(menuBar2) 
          diswin.Bind(wx.EVT_MENU, self.OnToBitmap2, id=200) 
    
      if flagfile3 != 0: 
        for i in xrange(len(discfm)):  
          ii = i+1      
          print >> fileout, "%5i" %ii, "%12.4f" %anu[i],"%10i" %sumnd12[i], "%10.6f" %discfm[i]

          dpanelm.Bind(wx.EVT_PAINT, self.DcDivm)
          dpanelm.Refresh()

          menuBar4 = wx.MenuBar()
# export
          exportMenu4 = wx.Menu()
          exportMenu4.Append(400, "graphics to png")
          menuBar4.Append(exportMenu4, "Export")
          diswinm.SetMenuBar(menuBar4) 
          diswinm.Bind(wx.EVT_MENU, self.OnToBitmap4, id=400) 
       
      return

#-------------------------------------
# Put DC on the window

    def DcDiv(self, evt): 
       global gw2, gh2 
 
       error_mes = tmes.GetValue()   
       if not error_mes:

        dc = wx.PaintDC(dpanel)
        dc.SetBackground(wx.Brush(dcolor))
        dc.Clear()
        (gw2, gh2) = dc.GetSize() 
        self.OnPaintDiv(dc)

#-------------------------------------
# Paint discrepancy curve

    def OnPaintDiv(self, dc): 

       ixd = zeros(ndfun-1) 
       iyd = zeros(ndfun-1)

       maxdiv = max(discf) 
       if maxdiv < 1.0: maxdiv = 1 
       mindiv = 0 

       dminmax = maxdiv
         
       dc.SetFont(font2)   
       dc.DrawText('Discrepancy function', wtb, 5) 
       dc.SetPen(wx.Pen('black',2))
       dc.DrawLine(lxrmind,lslcyd,lxrmind,lyrmind)
       dc.DrawLine(lxrmind,lslcyd,lxrmind+laxexd,lslcyd)

       for i in xrange(ndfun-1):

        ixd[i] = lxrmind+lenxd*i 
        iyd[i] = lslcyd-laxeyd*(discf[i]/dminmax)

        if i > 0: 
           dc.SetPen(wx.Pen(col3,3))
           dc.DrawLine(ixd[i-1], iyd[i-1], ixd[i], iyd[i]) 

       iyc = lslcyd-laxeyd*(1./dminmax)
       iym = lslcyd-laxeyd*(0.5/dminmax)

       ixs = float(laxexd)/10.0
       itxt = -0.1
       dc.SetPen(wx.Pen('black',1))
       dc.SetFont(font1)
       for i in xrange(11): 
        ixss = lxrmind+ixs*i
        itxt = itxt+0.1
        if i > 0: 
         dc.DrawLine(ixss, lslcyd+2, ixss, lslcyd-4) 
        dc.SetTextForeground('black')
        dc.DrawText(str(itxt), ixss-wf13/2, lslcyd+hf13/2)

       dc.SetPen(wx.Pen('black',1))
       dc.DrawLine(lxrmind,iyc,lxrmind+laxexd,iyc)
       dc.DrawLine(lxrmind,iym,lxrmind+laxexd,iym)
       dc.SetFont(font1)
       dc.SetTextForeground('black')
       dc.DrawText("1.0", lxrmind-1.2*wf13, iyc-hf13/2)
       dc.SetTextForeground('black')
       dc.DrawText("0.5", lxrmind-1.2*wf13, iym-hf13/2)    
       
       return

#-------------------------------------
# Dialog with entering name and dimensions for png file -discrepancy curve

    def OnToBitmap2(self, evt):
        
        id = evt.GetId()
        gwidth = str(gw2)
        gheight = str(gh2)
      
        dlg=wx.Dialog(self, -1, "Export picture to bitmap file",(250,250*hpar),(250,180*hpar))
        mainsizer = wx.BoxSizer(wx.VERTICAL)
        hsizerFile = wx.BoxSizer(wx.HORIZONTAL)
        hsizer1 = wx.BoxSizer(wx.HORIZONTAL)
        hsizer2 = wx.BoxSizer(wx.HORIZONTAL)
        hsizerBtn = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(dlg,-1,"File name:", (10,10*hpar))

        dlg.inputFilename = wx.TextCtrl(dlg,-1,"", (80,10*hpar), (160,20*hpar))
        hsizerFile.Add(label,0, wx.ALIGN_CENTRE|wx.ALL, 5)
        hsizerFile.Add(dlg.inputFilename,1, wx.EXPAND|wx.ALL, 5)
        mainsizer.Add(hsizerFile)
        
        labelResWidth = wx.StaticText(dlg, -1, "Width:", (10,40*hpar))
        dlg.inputResWidth = wx.TextCtrl(dlg, -1, value=str(gwidth), pos=(80,40*hpar), size=(50,20*hpar))
        hsizer1.Add(labelResWidth,0,wx.ALL|wx.ALIGN_CENTER|wx.ALIGN_LEFT,5)
        hsizer1.Add(dlg.inputResWidth,0,wx.ALL|wx.ALIGN_RIGHT,5)
        labelResHeight = wx.StaticText(dlg, -1, "Height:", (10,70*hpar))
        dlg.inputResHeight = wx.TextCtrl(dlg, -1, value=str(gheight), pos=(80,70*hpar), size=(50,20*hpar))
        hsizer2.Add(labelResHeight,0,wx.ALL|wx.ALIGN_CENTER|wx.ALIGN_LEFT,5)
        hsizer2.Add(dlg.inputResHeight,0,wx.ALL|wx.ALIGN_RIGHT,5)

        okBtn = wx.Button(dlg, wx.ID_OK, "OK", (30,100)) 
        cancelBtn = wx.Button(dlg, wx.ID_CANCEL, "Cancel", (130,100))
        hsizerBtn.Add(okBtn,0,wx.ALIGN_CENTER,5)
        hsizerBtn.Add(cancelBtn,0,wx.ALIGN_CENTER,5)
        
        mainsizer.Add(hsizer1, 0, wx.ALL,5)
        mainsizer.Add(hsizer2, 0, wx.ALL,5)
        mainsizer.Add(hsizerBtn, 0, wx.ALL,5)
        self.SetSizer(mainsizer)
   
        self.MakeBitmapFile2(dlg)

#-------------------------------------
# Function makes png file from current image on the screen

    def MakeBitmapFile2(self, dlg):

        if dlg.ShowModal() == wx.ID_OK:  
          width = dlg.inputResWidth.GetValue()
          height = dlg.inputResHeight.GetValue()   
          width = width.strip()
          height = height.strip()
          if len(width) == 0 or width.isspace() == True:
           tmes.SetValue(" Width is not defined")
           return 
          if width.isdigit() == False :
           tmes.SetValue(" Wrong symbol in the width parameter")
           return 
          if len(height) == 0 or height.isspace() == True:
           tmes.SetValue(" Height is not defined")
           return 
          if height.isdigit() == False :
           tmes.SetValue(" Wrong symbol in the height parameter")
           return 
                                    
          pngbuffer = wx.EmptyBitmap(int(dlg.inputResWidth.GetValue()),int(dlg.inputResHeight.GetValue()))
          pngdc = wx.MemoryDC(pngbuffer)
          pngdc.SelectObject(pngbuffer)     
          pngdc.SetBackground(wx.Brush(scolor))
          pngdc.Clear()
          self.OnPaintDiv(pngdc)       
 
          ttt=dlg.inputFilename.GetValue()
          sss=dfile1+"/"+ttt
          pngbuffer.SaveFile("%s.png" % sss,wx.BITMAP_TYPE_PNG)
          pngdc.SelectObject(wx.NullBitmap)

#-------------------------------------
# Put DC on the window

    def DcDivm(self, evt): 
       global gw4, gh4 
 
       error_mes = tmes.GetValue()   
       if not error_mes:

        dcm = wx.PaintDC(dpanelm)
        dcm.SetBackground(wx.Brush(dcolor))
        dcm.Clear()
        (gw4, gh4) = dcm.GetSize() 
        self.OnPaintDivm(dcm)

#-------------------------------------
# Paint discrepancy curve

    def OnPaintDivm(self, dcm): 

       self.ixdm = zeros(ndfun-1) 
       self.iydm = zeros(ndfun-1)

       maxdiv = max(discfm) 
       if maxdiv < 1.0: maxdiv = 1.0 
       mindiv = 0 

       dminmax = maxdiv
         
       dcm.SetFont(font2)    
       dcm.DrawText('Discrepancy function', wtb, 5)
       dcm.SetPen(wx.Pen('black',2))
       dcm.DrawLine(lxrmind,lslcyd,lxrmind,lyrmind)
       dcm.DrawLine(lxrmind,lslcyd,lxrmind+laxexd,lslcyd) 

       for i in xrange(ndfun-1):

        self.ixdm[i] = lxrmind+lenxd*i 
        self.iydm[i] = lslcyd-laxeyd*(discfm[i]/dminmax)
 
        if i > 0: 
           dcm.SetPen(wx.Pen(col3,3))
           dcm.DrawLine(self.ixdm[i-1],self.iydm[i-1], self.ixdm[i], self.iydm[i]) 

       iyc = lslcyd-laxeyd*(1./dminmax)
       iym = lslcyd-laxeyd*(0.5/dminmax)
        
       ixs = float(laxexd)/10.0
       itxt = -0.1
       dcm.SetPen(wx.Pen('black',1))
       dcm.SetFont(font1)
       for i in xrange(11): 
        ixss = lxrmind+ixs*i
        itxt = itxt+0.1
        if i > 0: 
         dcm.DrawLine(ixss, lslcyd+2, ixss, lslcyd-4) 
        dcm.SetTextForeground('black')
        dcm.DrawText(str(itxt), ixss-wf13/2, lslcyd+hf13/2)

       dcm.SetPen(wx.Pen('black',1))
       dcm.DrawLine(lxrmind,iyc,lxrmind+laxexd,iyc)
       dcm.DrawLine(lxrmind,iym,lxrmind+laxexd,iym)
       dcm.SetFont(font1)
       dcm.SetTextForeground('black')
       dcm.DrawText("1.0", lxrmind-1.2*wf13, iyc-hf13/2)
       dcm.SetTextForeground('black')
       dcm.DrawText("0.5", lxrmind-1.2*wf13, iym-hf13/2)  
       
       return

#-------------------------------------
# Dialog with entering name and dimensions for png file -histograms (1 and 2 files with the mask)

    def OnToBitmap4(self, evt):
        
        id = evt.GetId()
        gwidth = str(gw4)
        gheight = str(gh4)
      
        dlg=wx.Dialog(self, -1, "Export picture to bitmap file",(250,250*hpar),(250,180*hpar))
        mainsizer = wx.BoxSizer(wx.VERTICAL)
        hsizerFile = wx.BoxSizer(wx.HORIZONTAL)
        hsizer1 = wx.BoxSizer(wx.HORIZONTAL)
        hsizer2 = wx.BoxSizer(wx.HORIZONTAL)
        hsizerBtn = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(dlg,-1,"File name:", (10,10*hpar))

        dlg.inputFilename = wx.TextCtrl(dlg,-1,"", (80,10*hpar), (160,20*hpar))
        hsizerFile.Add(label,0, wx.ALIGN_CENTRE|wx.ALL, 5)
        hsizerFile.Add(dlg.inputFilename,1, wx.EXPAND|wx.ALL, 5)
        mainsizer.Add(hsizerFile)
        
        labelResWidth = wx.StaticText(dlg, -1, "Width:", (10,40*hpar))
        dlg.inputResWidth = wx.TextCtrl(dlg, -1, value=str(gwidth), pos=(80,40*hpar), size=(50,20*hpar))
        hsizer1.Add(labelResWidth,0,wx.ALL|wx.ALIGN_CENTER|wx.ALIGN_LEFT,5)
        hsizer1.Add(dlg.inputResWidth,0,wx.ALL|wx.ALIGN_RIGHT,5)
        labelResHeight = wx.StaticText(dlg, -1, "Height:", (10,70*hpar))
        dlg.inputResHeight = wx.TextCtrl(dlg, -1, value=str(gheight), pos=(80,70*hpar), size=(50,20*hpar))
        hsizer2.Add(labelResHeight,0,wx.ALL|wx.ALIGN_CENTER|wx.ALIGN_LEFT,5)
        hsizer2.Add(dlg.inputResHeight,0,wx.ALL|wx.ALIGN_RIGHT,5)

        okBtn = wx.Button(dlg, wx.ID_OK, "OK", (30,100)) 
        cancelBtn = wx.Button(dlg, wx.ID_CANCEL, "Cancel", (130,100))
        hsizerBtn.Add(okBtn,0,wx.ALIGN_CENTER,5)
        hsizerBtn.Add(cancelBtn,0,wx.ALIGN_CENTER,5)
        
        mainsizer.Add(hsizer1, 0, wx.ALL,5)
        mainsizer.Add(hsizer2, 0, wx.ALL,5)
        mainsizer.Add(hsizerBtn, 0, wx.ALL,5)
        self.SetSizer(mainsizer)
   
        self.MakeBitmapFile4(dlg)

#-------------------------------------
# Function makes png file from current image on the screen

    def MakeBitmapFile4(self, dlg):

        if dlg.ShowModal() == wx.ID_OK:  
          width = dlg.inputResWidth.GetValue()
          height = dlg.inputResHeight.GetValue()   
          width = width.strip()
          height = height.strip()
          if len(width) == 0 or width.isspace() == True:
           tmes.SetValue(" Width is not defined")
           return 
          if width.isdigit() == False :
           tmes.SetValue(" Wrong symbol in the width parameter")
           return 
          if len(height) == 0 or height.isspace() == True:
           tmes.SetValue(" Height is not defined")
           return 
          if height.isdigit() == False :
           tmes.SetValue(" Wrong symbol in the height parameter")
           return 
                                    
          pngbuffer = wx.EmptyBitmap(int(dlg.inputResWidth.GetValue()),int(dlg.inputResHeight.GetValue()))
          pngdc = wx.MemoryDC(pngbuffer)
          pngdc.SelectObject(pngbuffer)     
          pngdc.SetBackground(wx.Brush(scolor))
          pngdc.Clear()
          self.OnPaintDivm(pngdc)       
 
          ttt=dlg.inputFilename.GetValue()
          sss=dfile1+"/"+ttt
          pngbuffer.SaveFile("%s.png" % sss,wx.BITMAP_TYPE_PNG)
          pngdc.SelectObject(wx.NullBitmap)

#-------------------------------------
# Correlation of peaks

    def P2sig(self,pcut,fmin,fmax,fave,fsigma,chis):
      global s0, den0

      dhis = (fmax-fmin)/mhis

      for ih in xrange(1,mhis):

        if chis[ih] > pcut:
          t = float((chis[ih]-pcut))/float(chis[ih]-chis[ih-1])   
          s0 = fmin+dhis*(ih-1-t)
          den0 = s0*fsigma+fave
          return

      s0 = fmax
      den0 = s0*fsigma+fave  

      return

#-------------------------------------
# Cbased-cut-correlation

    def Ccvolc(self, ipeak, isec, pcut):
      global sumnod, sumc1, sumc2, ccn, ccc
      global fsum1rcn, fsum2rcn, fsum11rcn, fsum22rcn, fsum12rcn
      global fsum1rcc1, fsum1rcc2, fsum1rcc3, fsum1rcc4, fsum1rcc5, fsum1rcc6, fsum1rcc7
      global fsum2rcc1, fsum2rcc2, fsum2rcc3, fsum2rcc4, fsum2rcc5, fsum2rcc6, fsum2rcc7
      global fsum11rcc1, fsum11rcc2, fsum11rcc3, fsum11rcc4, fsum11rcc5, fsum11rcc6, fsum11rcc7
      global fsum22rcc1, fsum22rcc2, fsum22rcc3, fsum22rcc4, fsum22rcc5, fsum22rcc6, fsum22rcc7
      global fsum12rcc1, fsum12rcc2, fsum12rcc3, fsum12rcc4, fsum12rcc5, fsum12rcc6, fsum12rcc7

      v1 = vmap1-pcut
      v2 = vmap2-pcut
     
      v1 = np.where(v1 >= 0.0, v1, 0.0)
      v2 = np.where(v2 >= 0.0, v2, 0.0)

      iv1 = np.where(v1 > 0.0)
      iv1 =  iv1[0]
      iv2 = np.where(v2 > 0.0)
      iv2 =  iv2[0]
      ins = np.intersect1d(iv1,iv2) 

      nnodes = len(iv1)+len(iv2)-len(ins)
      sumnod[ipeak] = sumnod[ipeak]+nnodes

      fsum1rcn[ipeak] = fsum1rcn[ipeak]+sum(v1)
      fsum2rcn[ipeak] = fsum2rcn[ipeak]+sum(v2)
      fsum11rcn[ipeak] = fsum11rcn[ipeak]+sum(v1*v1)
      fsum22rcn[ipeak] = fsum22rcn[ipeak]+sum(v2*v2)
      fsum12rcn[ipeak] = fsum12rcn[ipeak]+sum(v1*v2) 

      iv11 = np.where(v1 == 0.0)
      iv11 =  iv11[0]
      ins1 = np.intersect1d(iv11,iv2) 

      iv11 = np.where(v2 == 0.0)
      iv11 =  iv11[0]
      ins2 = np.intersect1d(iv11,iv1) 
      
      vv1 = np.take(v1, ins)
      vv11 = np.take(v1, ins1)
      vv111 = np.take(v1, ins2)
      vccc1 = concatenate([vv1, vv11])
      vccc1 = concatenate([v1, vv111])

      vv1 = np.take(v2, ins)
      vv11 = np.take(v2, ins1)
      vv111 = np.take(v2, ins2)
      vccc2 = concatenate([vv1, vv11])
      vccc2 = concatenate([v2, vv111])

      s1 = sum(v1)
      s2 = sum(v2)
      s11 = sum(v1*v1)
      s22 = sum(v2*v2)
      s12 = sum(v1*v2) 

      if ipeak == 0:
             fsum1rcc1.append(s1)
             fsum2rcc1.append(s2)
             fsum11rcc1.append(s11)
             fsum22rcc1.append(s22)
             fsum12rcc1.append(s12) 
      elif ipeak == 1:
             fsum1rcc2.append(s1)
             fsum2rcc2.append(s2)
             fsum11rcc2.append(s11)
             fsum22rcc2.append(s22)
             fsum12rcc2.append(s12) 
      elif ipeak == 2:
             fsum1rcc3.append(s1)
             fsum2rcc3.append(s2)
             fsum11rcc3.append(s11)
             fsum22rcc3.append(s22)
             fsum12rcc3.append(s12) 
      elif ipeak == 3:
             fsum1rcc4.append(s1)
             fsum2rcc4.append(s2)
             fsum11rcc4.append(s11)
             fsum22rcc4.append(s22)
             fsum12rcc4.append(s12) 
      elif ipeak == 4:
             fsum1rcc5.append(s1)
             fsum2rcc5.append(s2)
             fsum11rcc5.append(s11)
             fsum22rcc5.append(s22)
             fsum12rcc5.append(s12) 
      elif ipeak == 5:
             fsum1rcc6.append(s1)
             fsum2rcc6.append(s2)
             fsum11rcc6.append(s11)
             fsum22rcc6.append(s22)
             fsum12rcc6.append(s12)
      else:
             fsum1rcc7.append(s1)
             fsum2rcc7.append(s2)
             fsum11rcc7.append(s11)
             fsum22rcc7.append(s22)
             fsum12rcc7.append(s12)  
              
      return
        
#-------------------------------------
# Cbased-qrank-correlation

    def Ccqrnk(self, isec, qrank):
      global sumnodq, sumc1q, sumc2q, ccnq, cccq
      global fsum1rcnq, fsum2rcnq, fsum11rcnq, fsum22rcnq, fsum12rcnq
      global fsum1rccq, fsum2rccq, fsum11rccq, fsum22rccq, fsum12rcc1

      v1 = vmap1-qrank
      v2 = vmap2-qrank
     
      v1 = np.where(v1 >= 0.0, v1, 0.0)
      v2 = np.where(v2 >= 0.0, v2, 0.0)

      iv1 = np.where(v1 > 0.0)
      iv1 =  iv1[0]
      iv2 = np.where(v2 > 0.0)
      iv2 =  iv2[0]
      ins = np.intersect1d(iv1,iv2) 

      nnodes = len(iv1)+len(iv2)-len(ins)
      sumnodq = sumnodq+nnodes

      fsum1rcnq = fsum1rcnq+sum(v1)
      fsum2rcnq = fsum2rcnq+sum(v2)
      fsum11rcnq = fsum11rcnq+sum(v1*v1)
      fsum22rcnq = fsum22rcnq+sum(v2*v2)
      fsum12rcnq = fsum12rcnq+sum(v1*v2) 

      iv11 = np.where(v1 == 0.0)
      iv11 =  iv11[0]
      ins1 = np.intersect1d(iv11,iv2) 

      iv11 = np.where(v2 == 0.0)
      iv11 =  iv11[0]
      ins2 = np.intersect1d(iv11,iv1) 
      
      vv1 = np.take(v1, ins)
      vv11 = np.take(v1, ins1)
      vv111 = np.take(v1, ins2)
      vccc1 = concatenate([vv1, vv11])
      vccc1 = concatenate([v1, vv111])

      vv1 = np.take(v2, ins)
      vv11 = np.take(v2, ins1)
      vv111 = np.take(v2, ins2)
      vccc2 = concatenate([vv1, vv11])
      vccc2 = concatenate([v2, vv111])

      s1 = sum(v1)
      s2 = sum(v2)
      s11 = sum(v1*v1)
      s22 = sum(v2*v2)
      s12 = sum(v1*v2) 

      fsum1rccq.append(s1)
      fsum2rccq.append(s2)
      fsum11rccq.append(s11)
      fsum22rccq.append(s22)
      fsum12rccq.append(s12) 
              
      return

#-------------------------------------
# Save synthesis

    def OnSaveSynt(self, evt):
      global isave

      if btnSave[1].GetValue() == True and (flagfile1 == 0 or flagfile2 == 0 or flagfile3 != 0): 
        btnSave[0].SetValue(True)  
        btnSave[1].SetValue(False) 
     
      if btnSave[1].GetValue() == True and (flagfile1 != 0 and flagfile2 != 0 and flagfile3 == 0): 
         isave = 1 
         self.RankRes()
    
      return

    def NonSaveSynt(self, evt):
      global isave

      btnSave[1].SetValue(False)      
      isave = 0
    
      return
        
#-------------------------------------
# Close window

    def OnCloseWindow(self, evt):
        
        fileout.close()
        self.Destroy()
        if hiswin : hiswin.Destroy() 
        if diswin : diswin.Destroy()
        if diswinm : diswinm.Destroy()         

#-------------------------------------
# Clean up the message list 

    def CleanMes(self, evt):

     tmes.SetValue("")

#-------------------------------------
# Display of histograms (file 1 and file 2)

class Hist_Graph(wx.Frame):
    def __init__(self, parent) :
       global wwin, hwin, spanel

       wwin = 0.8*hd
       if flagfile3 != 0: 
         hwin = 0.9*wwin
       else: hwin = wwin/2

       txt = 'Histograms'
     
       wx.Frame.__init__(self, None, -1, title=txt, pos=(wppanel+20, 50), size=(wwin,hwin),
        style = wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX)) 

       spanel = self.spanel = wx.Panel(self, -1, pos=(0, 0), size=(wwin, hwin-bsz))
       spanel.SetBackgroundColour(scolor)

       bspanel = self.bspanel = wx.Panel(self, pos=(0, hwin-bsz), size=(wwin, bsz))

       menuBar1 = wx.MenuBar()
# export
       exportMenu1 = wx.Menu()
       exportMenu1.Append(100, "graphics to png")
       menuBar1.Append(exportMenu1, "Export")
       self.SetMenuBar(menuBar1) 
       self.Bind(wx.EVT_MENU, self.OnToBitmap1, id=100) 

       btnExit2 = wx.Button(bspanel, -1, 'Close', (wwin/2-wfcl, 0), (wfcl+20,hver))
       btnExit2.SetFont(font1)
       btnExit2.SetBackgroundColour(col5) 
       btnExit2.Bind(wx.EVT_BUTTON, self.OnCloseHist)

       wx.EVT_CLOSE(self, self.OnCloseHist) 

       spanel.Bind(wx.EVT_PAINT, self.DcHist)

       self.Show()
      
#-------------------------------------
# Close graphics window 

    def OnCloseHist(self, evt):
        self.Destroy()

#-------------------------------------
# Put DC on the window

    def DcHist(self, evt): 
       global spanel, gw1, gh1 

       error_mes = tmes.GetValue()
       if not error_mes:

        dc = wx.PaintDC(spanel)
        dc.SetBackground(wx.Brush(scolor))
        dc.Clear()
        (gw1, gh1) = dc.GetSize() 
        self.OnPaintHist(dc)

#-------------------------------------
# Paint histograms

    def OnPaintHist(self, dc): 
       global lxrmin, lyrmin, laxex, laxey, lslcy
       global maxhis, minhis, maxhisc, minhisc
       global minhisx, maxhisx, minhisxp, maxhisxp, minhisxm, maxhisxm, minhisxpm, maxhisxpm
       global minhisy, maxhisy, minhisyp, maxhisyp, minhisym, maxhisym, minhisypm, maxhisypm
       global ix, iax, iaxp, iaxm, iaxpm, iaxs, iaxps, iaxms, iaxpms, iayq, iaypq, iaymq, iaypmq, iyh10, iyh20, iyh1p, iyh2p

       lxrmin = 20
       lyrmin = 10*hpar+2*hf5

       wsz = lyrmin+hf13+20*hpar
       if flagfile3 == 0: laxey = 0.7*hwin-wsz

       laxex = 0.4*wwin 

       lslcy = laxey+lyrmin
       wwin2 = 0.5*wwin
       hwin2m = 0.5*hwin-40*hpar

       lenx = float(laxex/(shis-1))
       lenxc = float(laxex/(mhis-1))    

       if flagfile1 != 0 and flagfile2 != 0 and flagfile3 == 0: 
        ix = zeros(shis)
        iyh10 = zeros(shis)
        iyh20 = zeros(mhis)
        iyh1p = zeros(shis)
        iyh2p = zeros(mhis)

        minhisx = float(Stats1.split()[0])
        maxhisx = float(Stats1.split()[1])
        minhisy = min(chist1)
        maxhisy = max(chist1)
        iax = laxex*abs(minhisx)/(maxhisx-minhisx)
        iaxs = laxex*abs(float(Scals1)-minhisx)/(maxhisx-minhisx)
        iayq = laxey*float(Squan1)/(maxhisy-minhisy)

        minhisxp = float(Stats2.split()[0])
        maxhisxp = float(Stats2.split()[1])
        minhisyp = min(chist2)
        maxhisyp = max(chist2)
        iaxp = laxex*abs(minhisxp)/(maxhisxp-minhisxp)
        iaxps = laxex*abs(float(Scals2)-minhisxp)/(maxhisxp-minhisxp)
        iaypq = laxey*(float(Squan2)-minhisyp)/(maxhisyp-minhisyp)
      
        maxhis = max(max(khis1),max(khis2))  
        minhis = min(min(khis1),min(khis2))
        maxhisc = max(max(chis1),max(chis2)) 
        minhisc = min(min(chis1),min(chis2)) 
    
       dminmax = maxhis-minhis
       dminmaxc = maxhisc-minhisc 

       if flagfile1 != 0 and flagfile2 != 0 and flagfile3 != 0: 

        iyh1m = zeros(shis)
        iyh2m = zeros(mhis)
        iyh1pm = zeros(shis)
        iyh2pm = zeros(mhis)

        minhisxm = float(Stats11.split()[0])
        maxhisxm = float(Stats11.split()[1])
        minhisym = min(chist1m)
        maxhisym = max(chist1m)
        iaxm = laxex*abs(minhisxm)/(maxhisxm-minhisxm)
        iaxms = laxex*abs(float(Scals11)-minhisxm)/(maxhisxm-minhisxm)
        iaymq = laxey*(float(Squan11)-minhisym)/(maxhisym-minhisym)

        minhisxpm = float(Stats21.split()[0])
        maxhisxpm = float(Stats21.split()[1])
        minhisypm = min(chist2m)
        maxhisypm = max(chist2m)
        iaxpm = laxex*abs(minhisxpm)/(maxhisxpm-minhisxpm)
        iaxpms = laxex*abs(float(Scals21)-minhisxpm)/(maxhisxpm-minhisxpm)
        iaypmq = laxey*(float(Squan21)-minhisypm)/(maxhisypm-minhisypm)

        maxhism = max(max(khis1m),max(khis2m))  
        minhism = min(min(khis1m),min(khis2m))
        maxhiscm = max(max(chis1m),max(chis2m)) 
        minhiscm = min(min(chis1m),min(chis2m))  

        dminmaxm = maxhism-minhism
        dminmaxcm = maxhiscm-minhiscm
         
       if flagfile1 != 0 and flagfile2 != 0: 

        dc.SetFont(font2)   
        dc.SetTextForeground('black')  
        dc.DrawText('Hist1', 10, 5*hpar)
        dc.DrawText('Hist2', wwin2+10, 5*hpar) 
        if flagfile3 != 0:
         dc.DrawText('Hist1 mask', 10, hwin2m+5*hpar)
         dc.DrawText('Hist2 mask', wwin2+10, hwin2m+5*hpar) 
        dc.SetFont(font5)   
        dc.SetTextForeground('black')  
        dc.DrawText('frequency', wf14+150, 2*hpar)
        dc.DrawText('cumulative', wf14+150, hf5+2*hpar)
        dc.DrawText('frequency', wwin2+wf14+150, 2*hpar)
        dc.DrawText('cumulative', wwin2+wf14+150, hf5+2*hpar)
        if flagfile3 != 0:
         dc.DrawText('frequency', wf14+150, hwin2m+2*hpar)
         dc.DrawText('cumulative', wf14+150, hwin2m+hf5+2*hpar)
         dc.DrawText('frequency', wwin2+wf14+150, hwin2m+2*hpar)
         dc.DrawText('cumulative', wwin2+wf14+150, hwin2m+hf5+2*hpar)

        dc.SetPen(wx.Pen(col1,2)) 
        dc.DrawLine(wf14+wf5+160, 2*hpar+hf5*0.5, wf14+wf5+190, 2*hpar+hf5*0.5) 
        dc.DrawLine(wwin2+wf14+wf5+160, 2*hpar+hf5*0.5, wwin2+wf14+wf5+190, 2*hpar+hf5*0.5) 
        if flagfile3 != 0:
         dc.DrawLine(wf14+wf5+160, hwin2m+2*hpar+hf5*0.5, wf14+wf5+190, hwin2m+2*hpar+hf5*0.5) 
         dc.DrawLine(wwin2+wf14+wf5+160, hwin2m+2*hpar+hf5*0.5, wwin2+wf14+wf5+190, hwin2m+2*hpar+hf5*0.5) 
        dc.SetPen(wx.Pen(col2,2))  
        dc.DrawLine(wf14+wf5+160, 2*hpar+hf5*1.5, wf14+wf5+190, 2*hpar+hf5*1.5)
        dc.DrawLine(wwin2+wf14+wf5+160, 2*hpar+hf5*1.5, wwin2+wf14+wf5+190, 2*hpar+hf5*1.5)
        if flagfile3 != 0:
         dc.DrawLine(wf14+wf5+160, hwin2m+2*hpar+hf5*1.5, wf14+wf5+190, hwin2m+2*hpar+hf5*1.5)
         dc.DrawLine(wwin2+wf14+wf5+160, hwin2m+2*hpar+hf5*1.5, wwin2+wf14+wf5+190, hwin2m+2*hpar+hf5*1.5)

        dc.SetPen(wx.Pen('black',2))
        dc.DrawLine(lxrmin,lslcy+hpar,lxrmin+laxex,lslcy+hpar)
        dc.DrawLine(lxrmin+iax,lslcy,lxrmin+iax,lyrmin)
        dc.DrawLine(wwin2+lxrmin,lslcy+hpar,wwin2+lxrmin+laxex,lslcy+hpar)
        dc.DrawLine(wwin2+lxrmin+iaxp,lslcy,wwin2+lxrmin+iaxp,lyrmin)
        dc.SetPen(wx.Pen(col6,2))
        dc.DrawLine(lxrmin+iaxs,lslcy,lxrmin+iaxs,lyrmin)
        dc.DrawLine(wwin2+lxrmin+iaxps,lslcy,wwin2+lxrmin+iaxps,lyrmin)
        dc.DrawLine(lxrmin,lslcy-iayq,lxrmin+laxex,lslcy-iayq)
        dc.DrawLine(wwin2+lxrmin,lslcy-iaypq,wwin2+lxrmin+laxex,lslcy-iaypq)
        if flagfile3 != 0:
         dc.SetPen(wx.Pen('black',2))
         dc.DrawLine(lxrmin,hwin2m+lslcy+hpar,lxrmin+laxex,hwin2m+lslcy+hpar)
         dc.DrawLine(lxrmin+iaxm,hwin2m+lslcy,lxrmin+iaxm,hwin2m+lyrmin)
         dc.DrawLine(wwin2+lxrmin,hwin2m+lslcy+hpar,wwin2+lxrmin+laxex,hwin2m+lslcy+hpar)
         dc.DrawLine(wwin2+lxrmin+iaxpm,hwin2m+lslcy,wwin2+lxrmin+iaxpm,hwin2m+lyrmin)
         dc.SetPen(wx.Pen(col6,2))
         dc.DrawLine(lxrmin+iaxms,hwin2m+lslcy,lxrmin+iaxms,hwin2m+lyrmin)
         dc.DrawLine(wwin2+lxrmin+iaxpms,hwin2m+lslcy,wwin2+lxrmin+iaxpms,hwin2m+lyrmin)
         dc.DrawLine(lxrmin,hwin2m+lslcy-iaymq,lxrmin+laxex,hwin2m+lslcy-iaymq)
         dc.DrawLine(wwin2+lxrmin,hwin2m+lslcy-iaypmq,wwin2+lxrmin+laxex,hwin2m+lslcy-iaypmq)

        dc.SetFont(font4)   
        dc.DrawText(str(minhisx), 5, lslcy+5*hpar)
        dc.DrawText(str(maxhisx), lxrmin+laxex-wf1/2, lslcy+5*hpar)
        dc.DrawText(str(minhisxp), wwin2+5, lslcy+5*hpar)
        dc.DrawText(str(maxhisxp), wwin2+lxrmin+laxex-wf1/2, lslcy+5*hpar) 
        if flagfile3 != 0:
         dc.DrawText(str(minhisxm), 5, hwin2m+lslcy+5*hpar)
         dc.DrawText(str(maxhisxm), lxrmin+laxex-wf1/2, hwin2m+lslcy+5*hpar)
         dc.DrawText(str(minhisxpm), wwin2+5, hwin2m+lslcy+5*hpar)
         dc.DrawText(str(maxhisxpm), wwin2+lxrmin+laxex-wf1/2, hwin2m+lslcy+5*hpar) 
   
        for i in xrange(shis):
         ix[i] = lxrmin+lenx*i
         iyh10[i] = lslcy-laxey*((khis1[i]-minhis)/dminmax)
         iyh20[i] = lslcy-laxey*((chis1[i]-minhisc)/dminmaxc)
         if flagfile3 != 0:
          iyh1m[i] = hwin2m+lslcy-laxey*((khis1m[i]-minhism)/dminmaxm)
          iyh2m[i] = hwin2m+lslcy-laxey*((chis1m[i]-minhiscm)/dminmaxcm)

         if i > 0: 
           dc.SetPen(wx.Pen(col1,2))
           dc.DrawLine(ix[i-1], iyh10[i-1], ix[i], iyh10[i]) 
           if flagfile3 != 0:
            dc.DrawLine(ix[i-1], iyh1m[i-1], ix[i], iyh1m[i]) 
           dc.SetPen(wx.Pen(col2,2))
           dc.DrawLine(ix[i-1], iyh20[i-1], ix[i], iyh20[i])
           if flagfile3 != 0:
            dc.DrawLine(ix[i-1], iyh2m[i-1], ix[i], iyh2m[i])

        for i in xrange(shis):
         ix[i] = wwin2+lxrmin+lenx*i
         iyh1p[i] = lslcy-laxey*((khis2[i]-minhis)/dminmax)
         iyh2p[i] = lslcy-laxey*((chis2[i]-minhisc)/dminmaxc)
         if flagfile3 != 0:
          iyh1pm[i] = hwin2m+lslcy-laxey*((khis2m[i]-minhism)/dminmaxm)
          iyh2pm[i] = hwin2m+lslcy-laxey*((chis2m[i]-minhiscm)/dminmaxcm) 
         if i > 0:              
            dc.SetPen(wx.Pen(col1,2))
            dc.DrawLine(ix[i-1], iyh1p[i-1], ix[i], iyh1p[i])
            if flagfile3 != 0: 
             dc.DrawLine(ix[i-1], iyh1pm[i-1], ix[i], iyh1pm[i])
            dc.SetPen(wx.Pen(col2,2))
            dc.DrawLine(ix[i-1], iyh2p[i-1], ix[i], iyh2p[i])
            if flagfile3 != 0:
             dc.DrawLine(ix[i-1], iyh2pm[i-1], ix[i], iyh2pm[i])
       
       return

#-------------------------------------
# Dialog with entering name and dimensions for png file -histograms (1 and 2 files)

    def OnToBitmap1(self, evt):
        
        id = evt.GetId()
        gwidth = str(gw1)
        gheight = str(gh1)
      
        dlg=wx.Dialog(self, -1, "Export picture to bitmap file",(250,250*hpar),(250,180*hpar))
        mainsizer = wx.BoxSizer(wx.VERTICAL)
        hsizerFile = wx.BoxSizer(wx.HORIZONTAL)
        hsizer1 = wx.BoxSizer(wx.HORIZONTAL)
        hsizer2 = wx.BoxSizer(wx.HORIZONTAL)
        hsizerBtn = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(dlg,-1,"File name:", (10,10*hpar))

        dlg.inputFilename = wx.TextCtrl(dlg,-1,"", (80,10*hpar), (160,20*hpar))
        hsizerFile.Add(label,0, wx.ALIGN_CENTRE|wx.ALL, 5)
        hsizerFile.Add(dlg.inputFilename,1, wx.EXPAND|wx.ALL, 5)
        mainsizer.Add(hsizerFile)
        
        labelResWidth = wx.StaticText(dlg, -1, "Width:", (10,40*hpar))
        dlg.inputResWidth = wx.TextCtrl(dlg, -1, value=str(gwidth), pos=(80,40*hpar), size=(50,20*hpar))
        hsizer1.Add(labelResWidth,0,wx.ALL|wx.ALIGN_CENTER|wx.ALIGN_LEFT,5)
        hsizer1.Add(dlg.inputResWidth,0,wx.ALL|wx.ALIGN_RIGHT,5)
        labelResHeight = wx.StaticText(dlg, -1, "Height:", (10,70*hpar))
        dlg.inputResHeight = wx.TextCtrl(dlg, -1, value=str(gheight), pos=(80,70*hpar), size=(50,20*hpar))
        hsizer2.Add(labelResHeight,0,wx.ALL|wx.ALIGN_CENTER|wx.ALIGN_LEFT,5)
        hsizer2.Add(dlg.inputResHeight,0,wx.ALL|wx.ALIGN_RIGHT,5)

        okBtn = wx.Button(dlg, wx.ID_OK, "OK", (30,100)) 
        cancelBtn = wx.Button(dlg, wx.ID_CANCEL, "Cancel", (130,100))
        hsizerBtn.Add(okBtn,0,wx.ALIGN_CENTER,5)
        hsizerBtn.Add(cancelBtn,0,wx.ALIGN_CENTER,5)
        
        mainsizer.Add(hsizer1, 0, wx.ALL,5)
        mainsizer.Add(hsizer2, 0, wx.ALL,5)
        mainsizer.Add(hsizerBtn, 0, wx.ALL,5)
        self.SetSizer(mainsizer)
   
        self.MakeBitmapFile1(dlg)

#-------------------------------------
# Function makes png file from current image on the screen

    def MakeBitmapFile1(self, dlg):

        if dlg.ShowModal() == wx.ID_OK:  
          width = dlg.inputResWidth.GetValue()
          height = dlg.inputResHeight.GetValue()   
          width = width.strip()
          height = height.strip()
          if len(width) == 0 or width.isspace() == True:
           tmes.SetValue(" Width is not defined")
           return 
          if width.isdigit() == False :
           tmes.SetValue(" Wrong symbol in the width parameter")
           return 
          if len(height) == 0 or height.isspace() == True:
           tmes.SetValue(" Height is not defined")
           return 
          if height.isdigit() == False :
           tmes.SetValue(" Wrong symbol in the height parameter")
           return 
                                    
          pngbuffer = wx.EmptyBitmap(int(dlg.inputResWidth.GetValue()),int(dlg.inputResHeight.GetValue()))
          pngdc = wx.MemoryDC(pngbuffer)
          pngdc.SelectObject(pngbuffer)     
          pngdc.SetBackground(wx.Brush(scolor))
          pngdc.Clear()
          self.OnPaintHist(pngdc)       
 
          ttt=dlg.inputFilename.GetValue()
          sss=dfile1+"/"+ttt
          pngbuffer.SaveFile("%s.png" % sss,wx.BITMAP_TYPE_PNG)
          pngdc.SelectObject(wx.NullBitmap)

#-------------------------------------
# Display of discrepancy curve

class Dis_Panel(wx.Frame):
    def __init__(self, parent) :
       global dpanel, lpanel

       wx.Frame.__init__(self, None, -1, title= 'Correlation coefficients, discrepancy function', 
        pos=(620*wpar, 100*hpar), size=(wwind,hwind), style = wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX)) 

       lpanel = wx.Panel(self, -1, pos=(0, 0), size=(wwind, slp)) 
       dpanel = wx.Panel(self, -1, pos=(0, slp), size=(wwind, shp))
       dpanel.SetBackgroundColour(dcolor)
       bspanel = self.bspanel = wx.Panel(self, pos=(0, slp+shp), size=(wwind, bsz))

       btnExit4 = wx.Button(bspanel, -1, 'Close', (wwind/2-wfcl, 5), (wds1+20,hver))
       btnExit4.SetFont(font1)
       btnExit4.SetBackgroundColour(col5) 
       btnExit4.Bind(wx.EVT_BUTTON, self.OnCloseDiv)

       wx.EVT_CLOSE(self, self.OnCloseDiv) 

       self.Show()

#-------------------------------------
# Close graphics window 

    def OnCloseDiv(self, evt):
        self.Destroy()

#-------------------------------------
# Display of discrepancy curve

class Dis_Panelm(wx.Frame):
    def __init__(self, parent) :
       global dpanelm, lpanelm

       wx.Frame.__init__(self, None, -1, title= 'Discrepancy function, correlation coefficients (mask)', 
        pos=(670*wpar, 150*hpar), size=(wwind,hwind), style = wx.DEFAULT_FRAME_STYLE & ~(wx.RESIZE_BORDER | wx.MAXIMIZE_BOX)) 

       lpanelm = wx.Panel(self, -1, pos=(0, 0), size=(wwind, slp)) 
       dpanelm = wx.Panel(self, -1, pos=(0, slp), size=(wwind, shp))
       dpanelm.SetBackgroundColour(dcolor)
       bspanel = self.bspanel = wx.Panel(self, pos=(0, slp+shp), size=(wwind, bsz))

       btnExit5 = wx.Button(bspanel, -1, 'Close', (wwind/2-wfcl, 5), (wds1+20,hver))
       btnExit5.SetFont(font1)
       btnExit5.SetBackgroundColour(col5) 
       btnExit5.Bind(wx.EVT_BUTTON, self.OnCloseDivm)

       wx.EVT_CLOSE(self, self.OnCloseDivm) 

       self.Show()

#-------------------------------------
# Close graphics window 

    def OnCloseDivm(self, evt):
        self.Destroy()

#-------------------------------------
def Dis_Inf(self):

       if flagfile3 == 0: lpn = lpanel
       if flagfile3 != 0: lpn = lpanelm

       if flagfile3 == 0: 
         cr = corrsc1
         cp = corrpc1
       else:
         cr = corrsc
         cp = corrpc
	 
       titq1 = wx.StaticText(lpn, -1, "correlation coefficient, sigma scale", pos =(wch,hds21))
       titq1.SetFont(font1) 
       titq11 = wx.StaticText(lpn, -1, "%10.3f" %cr, pos =(wch+wds15,hds21))
       titq11.SetFont(font1) 
       titq11.SetForegroundColour(col1) 
       titq2 = wx.StaticText(lpn, -1, "correlation coefficient,       rank", pos =(wch,2*hds21+10))
       titq2.SetFont(font1) 
       titq21 = wx.StaticText(lpn, -1, "%10.3f" %cp, pos =(wch+wds15,2*hds21+10))
       titq21.SetFont(font1) 
       titq21.SetForegroundColour(col1) 
       titq3 = wx.StaticText(lpn, -1, "rank", pos =(wch,3*hds21+20))
       titq3.SetFont(font1) 
       titq31 = wx.TextCtrl(lpn, -1, "%10.3f" %float(qrank), pos =(wch+wds12+5,3*hds21+20), size=(70,20), style = wx.CB_READONLY)
       titq31.SetFont(font1) 
       titq31.SetForegroundColour(col1) 
       titq4 = wx.StaticText(lpn, -1, "CCpeak", pos =(wch+wds12+wds14+30,3*hds21+20),)
       titq4.SetFont(font1)
       titq41 = wx.TextCtrl(lpn, -1, "%10.3f" %float(qpeak), pos=(wch+wds12+wds14+wds13+36,3*hds21+20), size=(70,20), style = wx.CB_READONLY)
       titq41.SetFont(font1) 
       titq41.SetForegroundColour(col1) 

       titc = wx.StaticText(lpn, -1, "Rank-based correlation coefficients", pos =(wch,4*hds21+40))
       titc.SetFont(font2) 
       titc1 = wx.StaticText(lpn, -1, ltitle, pos =(5+wds41,5*hds21+40))
       titc1.SetFont(font5) 
       tvec = wx.ListBox(lpn, choices= tcor, pos =(5,6.4*hds21+40), size=(wwind-20, hlb))
       tvec.SetFont(font4)
  
       return

#-------------------------------------
def Param_Dis(self):
       global wwind,hwind,wds1,wds12,wds13,wds14,wds15,hds21,wds41,hds41,wtb,wch,hlb,slp,shp
       global lxrmind,lyrmind,laxexd,laxeyd,lslcxd,lslcyd,lenxd
  
       dc = wx.ScreenDC()
       dc.SetFont(font1)
       wds1, hds1 = dc.GetTextExtent("Close")
       wds12, hds12 = dc.GetTextExtent("rank")
       wds13, hds13 = dc.GetTextExtent("CCpeak")
       wds14, hds14 = dc.GetTextExtent("100.0000")
       wds15, hds15 = dc.GetTextExtent("correlation coefficient, sigma scale")
       dc.SetFont(font2)
       wds2, hds2 = dc.GetTextExtent("Discrepancy function")
       wds21, hds21 = dc.GetTextExtent("Rank-based correlation coefficients")
       dc.SetFont(font4)
       wds4, hds4 = dc.GetTextExtent(ltitle)
       wds41, hds41 = dc.GetTextExtent("p")

       wwind = wds4+50
       if wds2 > wwind: wwind = wds2
       hwind = 0.8*hd

       slp = 0.45*hwind
       shp = 0.42*hwind       

       wtb = wwind/2-wds2/2

       wch = wwind/2-wds21/2
       hlb = nppeak*hds41+40

       lxrmind = 40
       lyrmind = 0.15*shp
  
       laxexd = wwind-lxrmind*2 
       laxeyd = 0.7*shp

       lslcxd = laxexd+lxrmind
       lslcyd = laxeyd+lyrmind

       lenxd = float(laxexd)/float(ndfun-2)

       return

#-------------------------------------
class App(wx.App):

    """ Application class """
    
    def OnInit(self):
        """ Function OnInit, initializating application, making main frame"""
        self.appFrame = InsertFrame(parent=1, id=-1)
        self.appFrame.Show()
        return True
        
if __name__ == '__main__':
    app = App(False, "output")
    app.MainLoop()


